package jasper.element;
import jasper.element.operators.*;
import jasper.exceptions.*;
import java.util.*;
import jasper.element.interfaceAbstract.*;
//Axiomatic Translation, version 1.1.0, @K.J.Smith 2007-2008, http://project.kjsmith.net/
public abstract class QuantifierTerm extends Term implements Quantifier {

    private QuantifierList qlist = null;
    private Term term = null;
    
    protected QuantifierTerm (Term term, QuantifierList qlist, String name) 
        throws TermCompositionException {  
        super(name);
        if ((term==null)||(qlist==null)) { 
            throw new JasperRuntimeException();
        }
        this.term = term;
        this.qlist = qlist;
        if (this.checkTypeOK () == false) {
            throw new TermCompositionException();
        }
        this.setNemonic(this.nemonic);
    }
    
    public QuantifierList getQuantifierList () {
        return this.qlist;
    }
            
    public Term getTerm () {
        return this.term.copy();
    }
    
    public ArrayList descendList() {
        ArrayList out = new ArrayList();
        out.add(this);
        out.addAll(this.getTerm().descendList());
        //out.addAll(this.getQuantifierList().descendList());
        return out;
    }
    
    protected boolean checkTypeOK () {
        if (this.getTerm() instanceof TermElement) {
            return false;
        } else if (this.getTerm() instanceof QuantifierList) {
            return false;
        } else {
            return true;
        }
    }
    
    public boolean equals (Term term){
        if (term==null) {
            throw new JasperRuntimeException();
        }
        if ( ((term instanceof QuantifierTerm)==false) 
           || (((QuantifierTerm)term).getQuantifierList().equals(this.getQuantifierList())==false) 
           || ((((QuantifierTerm)term).getTerm().equals(this.getTerm()))==false) ) {
            return false;
        } else {
            return true;
        }
        
    }
    
    public String toString () {
        String str = "";
        str += this.getName();
        str += "([";
        str += this.getQuantifierList().toString();
        str += "],";
        str += this.getTerm().toString();
        str += ")";
        return str;
    }
    
    public String inString () {
        String str = "";
        str += this.getNemonic();
        str += "([";
        str += this.getQuantifierList().inString();
        str += "],";
        str += this.getTerm().inString();
        str += ")";
        return str;
    }
    
    public String asString() {
        return this.toString();
    }
    
//    public static void main(String[] args) {
//        ;
//    }
}
