package jasper.element.axioms;
import jasper.element.symbols.*;
import jasper.element.*;
import java.util.*;
import jasper.data.*;
import jasper.element.operators.*;
//Axiomatic Translation, version 1.1.0, @K.J.Smith 2007-2008, http://project.kjsmith.net/
public class AxiomT extends Axiom {

    private final String name = "AxiomT";
    //Reflexive  []p->p	Ax( ¬Q[]p(x) \/ Qp(x) )
    public AxiomT(ModalityIndex index) {
        super(index);
    }
    
    //Ax( ¬Q[]p(x) \/ Qp(x) )
    protected final Term getResult(InstantiationSet iset) {
        And returnedTerm = null;
        SymbolCache sc = this.getTM().getSymbolCache();
        FOLVariable X = sc.getVariable(VarX);
        Iterator it = iset.getBoxISet().iterator();
        
        while (it.hasNext()) {
            Term out = null;
            Box def = ((Box) it.next()).copy();
            Predicate symbolBoxP = def.copy().getP(); //Q[]p
            Predicate symbolP = def.copy().getTerm().getP(); //Qp
            
            symbolBoxP.setArg(X);
            Term symbolBoxPTerm = symbolBoxP.negate(); //¬Q[]p(x)
            symbolP.setArg(X); //Qp(x)
            
            out = new Forall(new Or(symbolBoxPTerm, symbolP), new QuantifierList(X));
            if (returnedTerm==null) {
                returnedTerm = new And(out);
            } else {
                returnedTerm.setTerm(out);
            }
        }
        return returnedTerm;
    }

    public Def[] getDef() { //no new terms
        return null;
    }
    
    public final String getName() {
        String out = this.name;
        if (this.isModeComposition()==true) {
            out += "o";
        }
        return out;
    }
    
    protected InstantiationSet getISet() { //none
        return null;
    }
//    public static void main(String[] args) {
//        ;
//    }
}
