package jasper.element.axioms;
import jasper.element.symbols.*;
import jasper.element.*;
import java.util.*;
import jasper.data.*;
import jasper.element.operators.*;
//Axiomatic Translation, version 1.1.0, @K.J.Smith 2007-2008, http://project.kjsmith.net/
public class AxiomTr extends Axiom {
    
    private final String name = "AxiomTr";

    public AxiomTr(ModalityIndex index) {
        super(index);
        this.setModeComposition(true);
        this.setModeCf5(true);
    }

    //Ax((¬Q[]p(x)\/Qp(x))/\(¬Qp(x)\/Q[]p(x)))
    protected final Term getResult(InstantiationSet iset) {
        And returnedTerm = null;
        SymbolCache sc = this.getTM().getSymbolCache();
        FOLVariable X = sc.getVariable(VarX);
        Iterator it = iset.getBoxISet().iterator();
        
        while (it.hasNext()) {
            Term out = null;
            Box def = ((Box) it.next()).copy();
            Predicate symbolBoxP = def.copy().getP(); 
            
            Predicate first1 = symbolBoxP.copy();
            first1.setArg(X);
            Term first1Term = first1.negate();
            
            Predicate second2 = symbolBoxP.copy();
            second2.setArg(X); 
            
            Predicate symbolP = def.getTerm().copy().getP();
            
            Predicate first2 = symbolP.copy();
            first2.setArg(X);
            
            Predicate second1 = symbolP.copy();
            second1.setArg(X);
            Term second1Term = second1.negate(); 
            
            Term firstTerm = new Or(first1Term, first2);
            Term secondTerm = new Or(second1Term, second2);
            out = new Forall(new And(firstTerm, secondTerm), new QuantifierList(X));
            if (returnedTerm==null) {
                returnedTerm = new And(out);
            } else {
                returnedTerm.setTerm(out);
            }
        }
        return returnedTerm;
    }

    public Def[] getDef() { 
        return null;
    }

    protected InstantiationSet getISet() {  
        return null;
    }
    
    public final String getName() {
        String out = this.name;
        if (this.isModeComposition()==true) {
            out += "o";
        }
        return out;
    }
//    public static void main(String[] args) {
//        ;
//    }
}
