package jasper.element.operators;
import jasper.element.interfaceAbstract.*;
import jasper.element.*;
import jasper.exceptions.*;
//Axiomatic Translation, version 1.1.0, @K.J.Smith 2007-2008, http://project.kjsmith.net/
public class Complement extends UnaryTerm implements Unary {

    private final static String SYMBOLNAME = "comp";
    private final char nemonic = '\u223C';
    
    public Complement(Term term) {
        super(term, Complement.SYMBOLNAME);
    }

    @Override
    public boolean equals(Term term) {
        if (term==null) {
            throw new JasperRuntimeException();
        }
        if ((term instanceof Complement) && (super.equals(term)==true) ) {
            return true;
        } else {
            return false;
        }
    }

    public Complement copy() {
        return new Complement(this.getTerm().copy());
    }

//    public static void main(String[] args) {
//        ;
//    }
}
