package jasper.element.operators;
import jasper.element.interfaceAbstract.*;
import jasper.element.*;
import jasper.exceptions.*;
//Axiomatic Translation, version 1.1.0, @K.J.Smith 2007-2008, http://project.kjsmith.net/
public class Equiv extends BinaryTerm implements Binary, Junctor {

    private final static String SYMBOLNAME = "equiv";
    private final char nemonic = '\u2194';
    
    public Equiv(Term term1, Term term2)
            throws TermCompositionException {
        super(term1, term2, Equiv.SYMBOLNAME);
    }

    @Override
    public boolean equals(Term term) {
        if (term==null) {
            throw new JasperRuntimeException();
        }
        if ((term instanceof Equiv) && (super.equals(term)==true)) { 
            return true;
        } else {
            return false;
        }
    }

    public Equiv copy() {
        return new Equiv(this.getFirstTerm().copy(), this.getSecondTerm().copy());
    }

//    public static void main(String[] args) {
//        ;
//    }
}
