package jasper.element.operators;
import jasper.element.interfaceAbstract.*;
import jasper.element.*;
import java.util.*;
import jasper.exceptions.*;
//Axiomatic Translation, version 1.1.0, @K.J.Smith 2007-2008, http://project.kjsmith.net/
public class Or extends NaryTerm implements Junctor, Nary {

    private final static String SYMBOLNAME = "or";
    private final char nemonic = '\u22C1'; //2228 22C1
    
    public Or(Term term)
            throws TermCompositionException {
        super(term, Or.SYMBOLNAME);
    }

    public Or(Term term1, Term term2)
            throws TermCompositionException {
        super(term1, term2, Or.SYMBOLNAME);
    }

    public Or(Term term1, Term term2, Term term3)
            throws TermCompositionException {
        super(term1, term2, term3, Or.SYMBOLNAME);
    }
    
    public Or(Term term1, Term term2, Term term3, Term term4)
            throws TermCompositionException {
        super(term1, term2, term3, term4, Or.SYMBOLNAME);
    }
    
    public Or(ArrayList list)
            throws TermCompositionException {
        super(list, Or.SYMBOLNAME);
    }
    
    @Override
    public boolean equals(Term term) {
        if (term==null) {
            throw new JasperRuntimeException();
        }
        if ((term instanceof Or) && (super.equals(term)==true)) { 
            return true;
        } else {
            return false;
        }
    }

    public Or copy() {
        ArrayList out = new ArrayList();
        Iterator it = super.getTerm().iterator();
        Or or;
        if (it.hasNext() == true) {
            or = new Or(((Term) it.next()).copy());
        } else {
            throw new TermCompositionException();
        }
        while (it.hasNext() == true) {
            or.setTerm(((Term) it.next()).copy());
        }
        return or;
    }

    @Override
    public String asString() {
        return super.asStringOr();
    }
//    public static void main(String[] args) {
//        ;
//    }
}
