package jasper.main;
import jasper.element.operators.*;
import jasper.element.*;
import jasper.element.symbols.*;
//Axiomatic Translation, version 1.1.0, @K.J.Smith 2007-2008, http://project.kjsmith.net/
public interface Constants {

    public static final int VarX = 0;
    public static final int VarY = 1;
    public static final int VarZ = 2;
    public static final int VarU = 3;
    public static final int VarV = 4;
    public static final int VarW = 5;
    public static final int VarA = 6;
    public static final int VarB = 7;
    public static final int VarC = 8;
    
    //1 T and(box(r,p),not(p))
    public static Term problemT = (new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")),
            (new ModalPredicate("p")).negate()));
    
//    public static Term problemT = (new ModalPredicate("p")).box(new ModalityIndex("r"));
    
    //2 B and(not(box(r,not(box(r,p)))),not(p))
    public static Term problemB = (new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")).negate().box(new ModalityIndex("r")).negate(),
            (new ModalPredicate("p")).negate()));        
    
    //3 4 ... and(box(r,p),not(box(r,box(r,p)))) 
    public static Term problem4 = (new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")),
            (new ModalPredicate("p")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate()
            ));
    
    //4 5 ... and(not(box(r,not(box(r,p)))),not(box(r,p))) 
    public static Term problem5 = (new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")).negate().box(new ModalityIndex("r")).negate(),
            (new ModalPredicate("p")).box(new ModalityIndex("r")).negate()
            ));
    
    //5 D ... and(box(r,p),box(r,not(p))) 
    public static Term problemD = (new And(
            (new ModalPredicate("p")).negate().box(new ModalityIndex("r")),
            (new ModalPredicate("p")).box(new ModalityIndex("r"))
            ));
    
    //6 M ... and(box(r,not(box(r,not(p)))),box(r,not(box(r,p)))) 
    public static Term problemM = (new And(
            (new ModalPredicate("p")).negate().box(new ModalityIndex("r")).negate().box(new ModalityIndex("r")),
            (new ModalPredicate("p")).box(new ModalityIndex("r")).negate().box(new ModalityIndex("r"))
            ));
    
    //7 alt1 ... and(not(box(r,not(p))),not(box(r,p))) 
    public static Term problemalt1 = (new And(
            (new ModalPredicate("p")).negate().box(new ModalityIndex("r")).negate(),
            (new ModalPredicate("p")).box(new ModalityIndex("r")).negate()
            ));
    
    //8  4^2 ... and(box(r,p),not(box(r,box(r,box(r,p))))) 
    public static Term problem42 = (new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")),
            (new ModalPredicate("p")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate()
            ));
    
    //9   4^3 ... and(box(r,p),not(box(r,box(r,box(r,box(r,p))))))
    public static Term problem43 = (new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")),
            (new ModalPredicate("p")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate()
            ));
    
    //10  5^2 ... and(not(box(r,box(r,not(box(r,p))))),not(box(r,p)))
    public static Term problem52 = (new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")).negate().box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate(),
            (new ModalPredicate("p")).box(new ModalityIndex("r")).negate()
            ));
    
    //11  5^3 ... and(not(box(r,box(r,box(r,not(box(r,p)))))),not(box(r,p)))
    public static Term problem53 = (new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")).negate().box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate(),
            (new ModalPredicate("p")).box(new ModalityIndex("r")).negate()
            ));
    
    //12  B^2 ... and(not(box(r,box(r,not(box(r,p))))),not(p))
    public static Term problemB2 = (new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")).negate().box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate(),
            (new ModalPredicate("p")).negate()
            ));
    
    //13  Cxt ... and(not(box(r,not(box(r,p)))),not(box(r,box(r,p))))
    public static Term problemCxt = (new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate(),
            (new ModalPredicate("p")).box(new ModalityIndex("r")).negate().box(new ModalityIndex("r")).negate()
            ));
    
    //14  aiml02_prop3iii and(
    //        not(box(r,not(box(r,not(and(box(r,p),not(q))))))),
    //        not(box(r,not(and(box(r,p),box(r,not(q))))))    )
    public static Term problemaiml02_prop3iii = new And(
            new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")),
            (new ModalPredicate("q")).negate() 
            ).negate().box(new ModalityIndex("r")).negate().box(new ModalityIndex("r")).negate(),
            new And(
            (new ModalPredicate("q")).negate().box(new ModalityIndex("r")),
            (new ModalPredicate("p")).box(new ModalityIndex("r"))
            ).negate().box(new ModalityIndex("r")).negate()
            );
    
    //15  amai02 and(
    //box(r,not(and(box(r,p),not(q)))),
    //not(box(r,not(
    //        and(box(r,p),
    //        not(box(r,not(and(box(r,p),not(q)))))
    //    ))))
    //)
    public static Term problemamai02 = new And(
            new And (
            (new ModalPredicate("p")).box(new ModalityIndex("r")),
            (new ModalPredicate("q")).negate()
            ).negate().box(new ModalityIndex("r")),
            new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")),
                new And (
                (new ModalPredicate("p")).box(new ModalityIndex("r")),
                (new ModalPredicate("q")).negate()
                ).negate().box(new ModalityIndex("r")).negate()
            ).negate().box(new ModalityIndex("r")).negate()
    );
    
    //16  amai02b and(
        //not(box(r,not(and(box(r,p),not(q))))),
        //not(box(r,not(
        //        and(
        //        box(r,p),
        //        box(r,not(and(box(r,p),not(q))))
        //        )
        //   )         )
        //)
    //)
    public static Term problemamai02b = new And(
        new And(
                (new ModalPredicate("p")).box(new ModalityIndex("r")),
                (new ModalPredicate("q")).negate()
        ).negate().box(new ModalityIndex("r")).negate(),
        new And (
                new And (
                        (new ModalPredicate("p")).box(new ModalityIndex("r")),
                        (new ModalPredicate("q")).negate()
                        ).negate().box(new ModalityIndex("r")),
                (new ModalPredicate("p")).box(new ModalityIndex("r"))
        ).negate().box(new ModalityIndex("r")).negate()
    );
        
    //17  dnq,dbq ... and(not(box(r,q)),not(box(r,not(box(r,q)))))
    public static Term problemdnqdbq = (new And(
            (new ModalPredicate("q")).box(new ModalityIndex("r")).negate().box(new ModalityIndex("r")).negate(),
            (new ModalPredicate("q")).box(new ModalityIndex("r")).negate()
            ));
    
    //18  ddddnq,bbp ... and(not(box(r,box(r,box(r,box(r,q))))),box(r,box(r,q)))
    public static Term problemddddnqbbp = (new And(
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r")),
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate()
            ));
    
    //19  dddnq,bq ... and(not(box(r,box(r,box(r,q)))),box(r,q))
    public static Term problemdddnqbq = (new And(
            (new ModalPredicate("q")).box(new ModalityIndex("r")),
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate()
            ));
    
    //20  ddddnq,bq ... and(not(box(r,box(r,box(r,box(r,q))))),box(r,q))
    public static Term problemddddnqbq = (new And(
            (new ModalPredicate("q")).box(new ModalityIndex("r")),
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate()
            ));
    
    //21  dddnq,bbq ... and(not(box(r,box(r,box(r,q)))),box(r,box(r,q)))
    public static Term problemdddnqbbq = (new And(
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r")),
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate()
            ));
    
    //22  ddnq,bq ... and(not(box(r,box(r,q))),box(r,q))
    public static Term problemddnqbq = (new And(
            (new ModalPredicate("q")).box(new ModalityIndex("r")),
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate()
            ));
    
    //23  dddnq,dp,bbp ... and(not(box(r,box(r,box(r,q)))),not(box(r,not(p))),box(r,box(r,q)))
    public static Term problemdddnqdpbbp = (new And(
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r")),
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate(),
            (new ModalPredicate("p")).negate().box(new ModalityIndex("r")).negate()
            ));
    
    //24  ddddnq,dp,bbp ... and(not(box(r,box(r,box(r,box(r,q))))),
        //not(box(r,not(p))),     box(r,box(r,q)))
    public static Term problemddddnqdpbbp = (new And(
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate(),
            (new ModalPredicate("p")).negate().box(new ModalityIndex("r")).negate(),
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r"))
            ));
    
    //25  bp,dddnp,g ... and(box(r,p),        not(box(r,box(r,box(r,p)))),
        //not(box(r,box(r,box(r,box(r,box(r,box(r,not(q)))))))))
    public static Term problembpdddnpg = (new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")),
            (new ModalPredicate("p")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate(),
            (new ModalPredicate("q")).negate().box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate()
            ));
    
    //26  bp,ddnp,g and(
    //box(r,p),
    //not(box(r,box(r,p))),
    //not(box(r,box(r,box(r,box(r,box(r,box(r,not(q)))))))),
    //not(box(r,box(r,box(r,box(r,box(r,box(r,not(t))))))))
    //)
    public static Term problembpddnpg = new And(
           (new ModalPredicate("p")).box(new ModalityIndex("r")),
           (new ModalPredicate("p")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate(),
           (new ModalPredicate("q")).negate().box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate(),
           (new ModalPredicate("t")).negate().box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate()
    );
    
    //27  bq,dddddnq ... and(box(r,p),not(box(r,box(r,box(r,box(r,box(r,p)))))))
    public static Term problembqdddddnq = (new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")),
            (new ModalPredicate("p")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate()
            ));
    
    //28  bq,dddddddnq ... and(box(r,p),not(box(r,box(r,box(r,box(r,box(r,box(r,box(r,p)))))))))
    public static Term problembqdddddddnq = (new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")),
            (new ModalPredicate("p")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate()
            ));
    
    //29  dddddnq,bbbq ... and(not(box(r,box(r,box(r,box(r,box(r,q)))))),box(r,box(r,box(r,q))))
    public static Term problemdddddnqbbbq = (new And(
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")),
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate()
            ));
    
    //30  ddddddnq,dp,bbp ... and(not(box(r,box(r,box(r,box(r,box(r,box(r,q)))))))
    //                        ,not(box(r,not(p))),  box(r,box(r,q)))
    public static Term problemddddddnqdpbbp = (new And(
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate(),
            (new ModalPredicate("p")).negate().box(new ModalityIndex("r")).negate(),
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r"))
            ));
    
    //31  bbp,dddd(q,dnp) and(
        //box(r,box(r,p)),
        //not(box(r,box(r,box(r,box(r,not(
        //        and(q,not(box(r,p)))
        //))))))
        //)
    public static Term problembbpddddqdnp = new And(
        (new ModalPredicate("p")).box(new ModalityIndex("r")).box(new ModalityIndex("r")),
        new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")).negate(),
            new ModalPredicate("q")
        ).negate().box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate()
    );
    
    //32  ddddnq,b(q,g) ... and(not(box(r,box(r,box(r,box(r,q))))),   box(r,p), box(r,q))
    public static Term problemddddnqbqg = (new And(
            (new ModalPredicate("p")).box(new ModalityIndex("r")),
            (new ModalPredicate("q")).box(new ModalityIndex("r")),
            (new ModalPredicate("q")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).box(new ModalityIndex("r")).negate()
            ));
    
    //33  demri1 not(and(
    //not(
    //  and(
    //  box(r,not(
    //            and(
    //            not(box(r,p)),
    //            not(box(r,q))))
    //            ),
    //  not(box(r,p)),
    //  not(box(r,q))
    //  )
    //),
    //not(
    //   and(
    //   not(
    //            and(
    //            not(box(r,p)),
    //            not(box(r,q)))
    //            ),
    //   not(box(r,not(
    //            and(
    //            not(box(r,p)),
    //            not(box(r,q)))))
    //            )
    //   )
    //)
    //))
    public static Term problemdemri1 = new Not (new And(
       new And(
            new And((new ModalPredicate("p")).box(new ModalityIndex("r")).negate(),
                    (new ModalPredicate("q")).box(new ModalityIndex("r")).negate()).negate().box(new ModalityIndex("r")),
            (new ModalPredicate("p")).box(new ModalityIndex("r")).negate(),        
            (new ModalPredicate("q")).box(new ModalityIndex("r")).negate()
       ).negate(),     
       new And (
            new And(
                (new ModalPredicate("p")).box(new ModalityIndex("r")).negate(),        
                (new ModalPredicate("q")).box(new ModalityIndex("r")).negate()
            ).negate(),
            new And(
                (new ModalPredicate("p")).box(new ModalityIndex("r")).negate(),        
                (new ModalPredicate("q")).box(new ModalityIndex("r")).negate()
            ).negate().box(new ModalityIndex("r")).negate()
       ).negate()             
    ));
    
    //33  demri2 and(
    //box(r,not(
    //        and(
    //        box(r,not(and(p,not(q)))),
    //        box(r,not(and(q,not(p)))),
    //        not(t))
    //)),
    //not(box(r,not(
    //        and(
    //        box(r,not(and(p,not(q)))),
    //        box(r,not(and(q,not(p)))),
    //        not(box(r,t)))
    //)))
    //)
    public static Term problemdemri2 = new And(
            new And ( 
                new And((new ModalPredicate("q")).negate(),
                         new ModalPredicate("p")).negate().box(new ModalityIndex("r")),
                new And((new ModalPredicate("p")).negate(),
                         new ModalPredicate("q")).negate().box(new ModalityIndex("r")),
                (new ModalPredicate("t")).negate()
            ).negate().box(new ModalityIndex("r")),
            new And ( 
                new And((new ModalPredicate("q")).negate(),
                         new ModalPredicate("p")).negate().box(new ModalityIndex("r")),
                new And((new ModalPredicate("p")).negate(),
                         new ModalPredicate("q")).negate().box(new ModalityIndex("r")),
                (new ModalPredicate("t")).box(new ModalityIndex("r")).negate()
            ).negate().box(new ModalityIndex("r")).negate()
    );
    
    //////////////
        //and(    not(box(r,not(box(a,p)))),
        //        not(box(a,not(box(r,not(p)))))    )
        public static Term problemCR = new And(
            
            (new ModalPredicate("p")).negate().box(new ModalityIndex("r")).negate().box(new ModalityIndex("a")).negate(),
            (new ModalPredicate("p")).box(new ModalityIndex("a")).negate().box(new ModalityIndex("r")).negate()
        );
                   
        //and(box(r,not(and(not(p),not(box(rb,not(p)))))),box(r,box(rb,box(ra,not(and(not(pa),not(pb),not(p)))))),box(r,box(rb,not(and(not(pb),not(box(ra,not(pb))))))),box(r,box(rb,not(and(not(p),not(box(ra,not(p))))))),box(r,not(box(rb,pb))),box(r,box(rb,not(box(ra,pa)))),not(box(r,p)))
        //public static Term problemdemri4 = null;
        
                
    //////////////
    public static final Term[] MMEXAMPLES = new Term[]
    {
        problemCR.setDescription("CR") //CR=0
        //problemdemri4.setDescription("demri4")  //demri4=1
    };
    
    public static final Term[] EXAMPLES = new Term[]
    {
        problemT.setDescription("T"), //T=0
        problemB.setDescription("B"),  //B=1
        problem4.setDescription("4"), //4=2
        problem5.setDescription("5"), //5=3
        problemD.setDescription("D"), //D=4
        problemM.setDescription("M"), //M=5
        problemalt1.setDescription("alt1"), //alt1=6              
        problem42.setDescription("4^2"), //4^2=7
        problem43.setDescription("4^3"), //4^3=8
        problem52.setDescription("5^2"), //5^2=9
        problem53.setDescription("5^3"), //5^3=10
        problemB2.setDescription("B^2"), //B^2=11
        problemCxt.setDescription("Cxt"), //Cxt=12
        problemaiml02_prop3iii.setDescription("aiml02_prop3iii"), //aiml02_prop3iii=13
        problemamai02.setDescription("amai02"), //amai02=14                    
        problemamai02b.setDescription("amai02b"), //amai02b=15
        problemdnqdbq.setDescription("dnq,dbq"), //dnq,dbq=16
        problemddddnqbbp.setDescription("ddddnq,bbp"), //ddddnq,bbp=17
        problemdddnqbq.setDescription("dddnq,bq"), //dddnq,bq=18
        problemddddnqbq.setDescription("ddddnq,bq"), //ddddnq,bq=19
        problemdddnqbbq.setDescription("dddnq,bbq"), //dddnq,bbq=20
        problemddnqbq.setDescription("ddnq,bq"), //ddnq,bq=21
        problemdddnqdpbbp.setDescription("dddnq,dp,bbp"), //dddnq,dp,bbp=22
        problemddddnqdpbbp.setDescription("ddddnq,dp,bbp"), //ddddnq,dp,bbp=23
        problembpdddnpg.setDescription("bp,dddnp,g"), //bp,dddnp,g=24
        problembpddnpg.setDescription("bp,ddnp,g_2"), //bp,ddnp,g=25
        problembqdddddnq.setDescription("bq,dddddnq"), //bq,dddddnq=26
        problembqdddddddnq.setDescription("bq,dddddddnq"), //bq,dddddddnq=27
        problemdddddnqbbbq.setDescription("dddddnq,bbbq"), //dddddnq,bbbq=28
        problemddddddnqdpbbp.setDescription("ddddddnq,dp,bbp"), //ddddddnq,dp,bbp=29
        problembbpddddqdnp.setDescription("bbp,dddd(q,dnp)"), //bbp,dddd(q,dnp)=30
        problemddddnqbqg.setDescription("ddddnq,b(q,g)"), //ddddnq,b(q,g)=31
        problemdemri1.setDescription("demri1"), //demri1=32
        problemdemri2.setDescription("demri2") //demri2=33 
    };

    public static final String[] DFGS = new String[]
    {
        "T.dfg", //=0
//        "simple.dfg",
        "B.dfg", //=1
        "4.dfg", //=2
        "5.dfg", //=3
        "D.dfg", //=4
        "M.dfg", //=5
        "alt1.dfg", //=6
        "4^2.dfg", //=7
        "4^3.dfg", //=8
        "5^2.dfg", //=9
        "5^3.dfg", //=10
        "B^2.dfg", //=11
        "Cxt.dfg", //=12
        "aiml02_prop3iii.dfg", //=13
        "amai02.dfg", //=14       
        "amai02b.dfg", //=15
        "dnq,dbq.dfg", //=16
        "ddddnq,bbp.dfg", //=17
        "dddnq,bq.dfg", //=18
        "ddddnq,bq.dfg", //=19
        "dddnq,bbq.dfg", //=20
        "ddnq,bq.dfg", //=21
        "dddnq,dp,bbp.dfg", //=22
        "ddddnq,dp,bbp.dfg", //=23
        "bp,dddnp,g.dfg", //=24
        "bp,ddnp,g_2.dfg", //=25
        "bq,dddddnq.dfg", //=26
        "bq,dddddddnq.dfg", //=27
        "dddddnq,bbbq.dfg", //=28
        "ddddddnq,dp,bbp.dfg", //=29
        "bbp,dddd(q,dnp).dfg", //=30
        "ddddnq,b(q,g).dfg", //=31
        "demri1.dfg", //=32
        "demri2.dfg" //=33
    };
    
    public static final String[] DFGS3 = new String[]
    {
        "CR" //=0
    };
    
    public static final String[] DFGS2 = new String[]
    {
        "T", //=0
        "B", //=1
        "4", //=2
        "5", //=3
        "D", //=4
        "M", //=5
        "alt1", //=6
        "4^2", //=7
        "4^3", //=8
        "5^2", //=9
        "5^3", //=10
        "B^2", //=11
        "Cxt", //=12
        "aiml02_prop3iii", //=13
        "amai02", //=14       
        "amai02b", //=15
        "dnq,dbq", //=16
        "ddddnq,bbp", //=17
        "dddnq,bq", //=18
        "ddddnq,bq", //=19
        "dddnq,bbq", //=20
        "ddnq,bq", //=21
        "dddnq,dp,bbp", //=22
        "ddddnq,dp,bbp", //=23
        "bp,dddnp,g", //=24
        //"bp,ddnp,g_2", //=25
//        "bq,dddddnq", //=26
//        "bq,dddddddnq", //=27
//        "dddddnq,bbbq", //=28
//        "ddddddnq,dp,bbp", //=29
//        "bbp,dddd(q,dnp)", //=30
//        "ddddnq,b(q,g)", //=31
//        "demri1", //=32
//        "demri2" //=33
    };
}


