package jasper.main;
import jasper.element.*;
import jasper.parse.*;
import java.io.*;
//Axiomatic Translation, version 1.1.0, @K.J.Smith 2007-2008, http://project.kjsmith.net/
public class ParseDFG implements DFGParserConstants {

    public ParseDFG (String filename, int mode) {
        String path = "src" + File.separatorChar + "jasper" + File.separatorChar + "parse" + File.separatorChar;
        filename = "test.txt";
        try {
            BufferedReader in = new BufferedReader(new FileReader(path + filename));
            String line;
            System.out.println("Contents of file ...");
            while ((line = in.readLine()) != null) {
                System.out.println(" > " + line);
            }
            in.close();
        } catch (FileNotFoundException fnfe) {
            fnfe.printStackTrace();
            System.exit(-1);
        } catch (IOException ioe) {
            ioe.printStackTrace();
            System.exit(-1);
        }
        DFGParser parser;
        Term outTerm = null;
        try {
            parser = new DFGParser(new FileInputStream(path + filename));
            outTerm=parser.Unit();
            System.out.println("Parsed successfully.");
            outTerm.print();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
            System.exit(-1);
        } catch (ParseException e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    private Term result = null;
    public Term getResult() {
        return this.result;
    }
    
    public ParseDFG(String file) {
        DFGParser parser;  
        Term outTerm = null;
        
        try {
            String tempfile = "tmp";
            boolean temp = Function.delete(tempfile);
//            if (temp==true) {
//                System.out.println("*********deleted");
//            } else {
//                System.out.println("*********Not deleted");
//            }
            PrintWriter pw = new PrintWriter(tempfile);
            pw.print(file);
            pw.flush();
            pw.close();
            parser = new DFGParser(new FileInputStream(tempfile));
            outTerm=parser.Unit();
            System.out.println("Parsed successfully.");
            //outTerm.print();
            this.result = outTerm.copy();
        } catch (FileNotFoundException e) {
            System.out.println(e.getMessage());
            System.exit(-1);
        } catch (ParseException e) {
            System.out.println(e.getMessage());
            System.exit(-1);
        }
    }
}
