package jasper.element.operators;
import jasper.element.interfaceAbstract.*;
import jasper.element.*;
import jasper.exceptions.*;
import java.util.*;
//Axiomatic Translation, version 1.1.0, @K.J.Smith 2007-2008, http://project.kjsmith.net/
public class And extends NaryTerm implements Junctor, Nary {

    private final static String SYMBOLNAME = "and";
    private final char nemonic = '\u22C0'; //22C0 or 2227
    //requires at least one term
    public And(Term term)
            throws TermCompositionException {
        super(term, And.SYMBOLNAME);
    }

    public And(Term term1, Term term2)
            throws TermCompositionException {
        super(term1, term2, And.SYMBOLNAME);
    }

    public And(Term term1, Term term2, Term term3)
            throws TermCompositionException {
        super(term1, term2, term3, And.SYMBOLNAME);
    }
    
    public And(Term term1, Term term2, Term term3, Term term4)
            throws TermCompositionException {
        super(term1, term2, term3, term4, And.SYMBOLNAME);
    }
    
    public And(ArrayList list)
            throws TermCompositionException {
        super(list, And.SYMBOLNAME);
    }
    
    @Override
    public boolean equals(Term term) {
        if (term==null) {
            throw new JasperRuntimeException();
        }
        if ((term instanceof And) && (super.equals(term)==true)) { 
//            System.out.println("found@And:"+term.toString()+":"+this.toString());
            return true;
        } else {
//            System.out.println("missed@And:"+term.toString()+":"+this.toString());
            return false;
        }
    }

    public And copy() {
        ArrayList out = new ArrayList();
        Iterator it = this.getTerm().iterator();
        And and;
        if (it.hasNext() == true) {
            and = new And(((Term) it.next()).copy());
        } else {
            throw new TermCompositionException();
        }
        while (it.hasNext() == true) {
            and.setTerm(((Term) it.next()).copy());
        }
        return and;
    }

//    public static void main(String[] args) {
//        ;
//    }
}
