package jasper.element.operators;
import jasper.element.interfaceAbstract.*;
import jasper.element.*;
import jasper.exceptions.*;
import jasper.element.symbols.*;
//Axiomatic Translation, version 1.1.0, @K.J.Smith 2007-2008, http://project.kjsmith.net/
public class Diamond extends ModalTerm implements Binary {

    private final static String SYMBOLNAME = "dia";
    private final char nemonic = '\u2662';
    
    public Diamond(ModalityIndex r, Term term)
            throws TermCompositionException {
        super(r, term, Diamond.SYMBOLNAME);
    }

    @Override
    public boolean equals(Term term) {
        if (term==null) {
            throw new JasperRuntimeException();
        }
        if ((term instanceof Diamond) && (super.equals(term)==true)) {
            return true;
        } else {
            return false;
        }
    }

    public Diamond copy() {
        return new Diamond(this.getIndex().copy(), this.getTerm().copy());
    }

//    public static void main(String[] args) {
//        ;
//    }
}
