package jasper.element.symbols;
import jasper.element.*;
import java.util.*;
import jasper.element.interfaceAbstract.*;
import jasper.exceptions.*;
//Axiomatic Translation, version 1.1.0, @K.J.Smith 2007-2008, http://project.kjsmith.net/
public class Predicate extends UnaryPredicate implements Unary {

    private FOLVariable variable = null;

    public Predicate(String name) {
        super(name);
    }

    public boolean equals(Term term) {
        if (term == null) {
            throw new JasperRuntimeException();
        }
        if ((term instanceof Predicate) 
                && ((this.getName().equals(term.getName()) == true) 
                   || (this.testShortName(this.getName(), term.getName()) == true)) 
                && (this.variable.equals(((Predicate) term).getArg()) == true)) {
            return true;
        } else {
            return false;
        }
    }

//    private boolean testShortName(String name1, String name2) {
//        SymbolCache sc = TranslationManager.getTransationManager().getSymbolCache();
//        
//        if ((this.isNumber(name1.substring(1))==false) 
//            && (this.isNumber(name2.substring(1))==false) ) {
//            return false;
//        }
//            
//        if ( (name1.substring(0,1)).equals((name2).substring(0, 1))==false ) {    
//            return false;
//        }
//        
//        System.out.println("IN: "+name1+" : "+name2);
//        //asumes only one name has been replaced by a number
//
//        if (this.isNumber(name1.substring(1)) == true) {
//            String recordedName = sc.getFromNameList(name1.substring(1));
//            System.out.println("recordedName1 for "+name1.substring(1)+"="+recordedName);
//            
//            if (recordedName != null) {
//                if (recordedName.equals(name2.substring(1))) {
//                    return true;
//                } else {
//                    return false;
//                }
//            } else {
//                System.out.println("&&&&&&&&&&&&&&&&&&&&&&&&&&&&&"+name1.substring(1)+"  "+name2.substring(1));
//                sc.recordName(name1.substring(1), name2.substring(1));
//                return true;
//            }
//        } else if (this.isNumber(name2.substring(1)) == true) {
//            String recordedName = sc.getFromNameList(name2.substring(1));
//            System.out.println("recordedName2 for "+name2.substring(1)+"="+recordedName);
//            if (recordedName != null) {
//                if (recordedName.equals(name1.substring(1))) {
//                    return true;
//                } else {
//                    return false;
//                }
//            } else {
//                System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%%"+name2.substring(1)+"  "+name1.substring(1));
//                sc.recordName(name2.substring(1), name1.substring(1));
//                return true;
//            }
//        } else {
//            return false;
//        }
//    }
    
    private boolean testShortName(String name1, String name2) {
        if ((this.isNumber(name1.substring(1)) == true) 
                || (this.isNumber(name2.substring(1)) == true)) {
            return true;
        } else {
            return false;
        }
    }

    private boolean isNumber(String s) {
        try {
            int i = Integer.parseInt(s);
            return true;
        } catch (NumberFormatException e) {
            return false;
        }
    }

    public void setArg(FOLVariable variable) {
        if (variable == null) {
            throw new JasperRuntimeException();
        }
        this.variable = variable;
    }

    public FOLVariable getArg() {
        if (this.variable != null) {
            return this.variable.copy();
        } else {
            return null;
        }
    }

    public ArrayList descendList() {
        ArrayList out = new ArrayList();
        out.add(this);
        return out;
    }

    public String toString() {
        String str = this.getName() + "(";
        if (this.variable == null) {
            str += null + ")";
        } else {
            str += this.variable.toString() + ")";
        }
        return str;
    }

    public String inString() {
        String str = this.getNemonic() + "(";
        if (this.variable == null) {
            str += null + ")";
        } else {
            str += this.variable.inString() + ")";
        }
        return str;
    }

    public String asString() {
        //return this.toString();
        String str = this.getName() + "_";
        if (this.variable == null) {
            str += null + "_";
        } else {
            str += this.variable.toString() + "_";
        }
        return str;
    }

    public Predicate copy() {
        Predicate out = new Predicate(this.getName());
        if (this.getArg() != null) {
            out.setArg(this.getArg());
        }
        return out;
    }

//    public static void main(String[] args) {
//        ;
//    }
}
