package jasper.element.symbols;
import jasper.element.interfaceAbstract.BoolTerm;
import jasper.element.*;
import java.util.*;
import jasper.exceptions.*;
//Axiomatic Translation, version 1.1.0, @K.J.Smith 2007-2008, http://project.kjsmith.net/
public class True extends Term implements BoolTerm {

    private final char nemonic = '\u22A4';
    
    public True() {
        super("true");
        this.setNemonic(this.nemonic);
    }

    public boolean equals(Term term) {
        if (term==null) {
            throw new JasperRuntimeException();
        }
        if (term instanceof True) {
            return true;
        } else {
            return false;
        }
    }
    
    public ArrayList descendList() {
        ArrayList out = new ArrayList();
        out.add(this);
        return out;
    }
    
    public String toString() {
        return this.getName();
    }

    public String inString() {
        return this.toString();
    }
    
    public String asString() {
        return this.toString();
    }
    
    public True copy() {
        return new True();
    }

//    public static void main(String[] args) {
//        ;
//    }
}
