package jasper.main;
import java.io.*;
//Axiomatic Translation, version 1.1.0, @K.J.Smith 2007-2008, http://project.kjsmith.net/
public class Function {

    private static final boolean DEBUG = false;

    public static final void println(String str) {
        if (Function.DEBUG == true) {
            System.out.println(str);
        }
    }

    /**
     * Make the specified directory
     * @param s the file system path
     */
    public static void mkdir(String s) {
        if (s == null) {
            return;
        }

        File file = new File(s);
        //if (!file.exists ())
        file.mkdirs();
    }

    /**
     * Make the specified file.
     * @param s the file system path
     */
    public static void makeFile(String s) {
        if (s == null) {
            return;
        }

        File file = new File(s);
        if (!file.exists()) {
            try {
                file.createNewFile();
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
    }

    /**
     * Read the contents of an ASCII files
     * @param file the file system path
     * @return the String read from the file.
     */
    public static String read(File file) {
        if (file == null) {
            return null;
        }

        StringBuffer buffer = new StringBuffer();
        BufferedReader reader = null;

        try {
            reader = new BufferedReader(new FileReader(file));
            String line;

            while ((line = reader.readLine()) != null) {
                buffer.append(line).append("\n");
            }

            reader.close();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }

        return buffer.toString();
    }

    /**
     * Save a file
     * @param file the file system path
     * @param s the contents of the saved file.
     */
    public static void save(File file, String s) {
        if ((file == null) || (s == null) || (s.length() == 0)) {
            return;
        }

        BufferedWriter writer = null;

        try {
            writer = new BufferedWriter(new FileWriter(file.getPath()));

            writer.write(s);
            writer.flush();
            writer.close();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * Remove file.
     * @param s the file system path
     */
    public static boolean delete(String s) {
        boolean successful = false;
        if ((s == null) && (s.length() == 0)) {
            return successful;
        }

        File file = new File(s);
        if ((file.exists()) && (!file.isDirectory())) {
            file.delete();
            successful = true;
        }
        return successful;
    }
}

