package jasper.main;
import java.util.regex.*;
import java.io.*;
//Axiomatic Translation, version 1.1.0, @K.J.Smith 2007-2008, http://project.kjsmith.net/
public class Run {

    private String result = null;
    
    public Run(String[] ax, String arg) {
        String ex = "/Users/kjsmith/bin/SPASSrelease";
        String argPath = "/Users/kjsmith/workspaceC/code/testsuite/extended/template/";
        String[] args = new String[4+ax.length];
        args[0]="nice";
        args[1]=ex;
        args[2]="-TimeLimit=2";
        for (int i=0; i < ax.length;i++) {
            args[i+3]=ax[i];
        }
        args[3+ax.length]=argPath+arg;
          
        StringBuffer sb = new StringBuffer();
        try {
            Process proc = Runtime.getRuntime().exec(args);
            //StreamHandler error = new StreamHandler(proc, StreamHandler.ERROR);
            StreamHandler output = new StreamHandler(proc, StreamHandler.STANDARD);
            //error.start();
            output.start();
            output.join();
            //int exitVal = proc.waitFor();
            //System.out.println("Process exitValue: " + exitVal);
            String captured = output.getResult();
            //System.out.println(captured);
            String singleLine = this.regs(captured, "FINAL TERM[^\\n]*[\\n]"); 
            //System.out.println(singleLine);
            String reducedSingleLine = this.delete(singleLine, "FINAL TERM:\\t");
            //System.out.println(reducedSingleLine);
            this.result = reducedSingleLine;
        } catch (IOException ioe) {
            ioe.printStackTrace();
            throw new RuntimeException(ioe);
        } catch (InterruptedException ie) {
            ie.printStackTrace();
            throw new RuntimeException(ie);
        }
    }

    public Run(String arg, String argPathPlus) {
        String ex = "/Users/kjsmith/bin/SPASSrelease";
        String argPath = "/Users/kjsmith/workspaceC/code/testsuite/extended/"+argPathPlus+"/";
        String[] args = new String[4];
        args[0]="nice";
        args[1]=ex;
        args[2]="-TimeLimit=2";
        args[3]=argPath+arg;
        
//        for (int i=0; i<args.length; i++) {
//            System.out.println("********"+args[i]);
//        }
        
        StringBuffer sb = new StringBuffer();
        try {
            Process proc = Runtime.getRuntime().exec(args);
            StreamHandler output = new StreamHandler(proc, StreamHandler.STANDARD);
            output.start();
            output.join();
            String captured = output.getResult();
            String singleLine = this.regs(captured, "FINAL TERM[^\\n]*[\\n]"); 
            String reducedSingleLine = this.delete(singleLine, "FINAL TERM:\\t");
            this.result = reducedSingleLine;
        } catch (IOException ioe) {
            ioe.printStackTrace();
            throw new RuntimeException(ioe);
        } catch (InterruptedException ie) {
            ie.printStackTrace();
            throw new RuntimeException(ie);
        }
    }
    
    public String getResult() {
        return this.result;
    }
    
    public String delete(String str, String regex) {
        Pattern p;
        Matcher m;
        StringBuffer sb;
        
        try {
            p = Pattern.compile(regex);
        } catch (PatternSyntaxException e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }

        m = p.matcher(str);
        return m.replaceAll ("");
    }
    
    public String regs(String str, String regex) {
        Pattern p;
        Matcher m;
        StringBuffer sb;
        
        try {
            p = Pattern.compile(regex);
        } catch (PatternSyntaxException e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }

        m = p.matcher(str);
        sb = new StringBuffer();
        while (m.find()) {
            //System.out.println("Found " + m.group()
            //+"  starting at index "+m.start()+" and ending at index "+m.end());
            sb.append(m.group()).append('\n');
        }
        return sb.toString();
    }
    
    private class StreamHandler extends Thread {

        private final InputStream is;
        private final String typeString;
        private OutputStream outs;
        private final String[] types = new String[]{"Error>",">"};
        private static final int ERROR = 0;
        private static final int STANDARD = 1;
        private StringBuffer result = new StringBuffer();
        private boolean print = false;
        
        private StreamHandler(Process process, int type) {
            this(process,type,null);
        }

        private StreamHandler(Process process, int type, String filename) {
            if (type==STANDARD) {
                this.is = process.getInputStream();
            } else if (type==ERROR) {
                this.is = process.getErrorStream();
            } else {
                throw new RuntimeException();
            }
            this.typeString = types[type];
            this.outs = null;
            try {
                if (filename!=null) {
                    this.outs = new FileOutputStream(filename);
                }
            } catch (FileNotFoundException fnfe) {
                fnfe.printStackTrace();                
            } 
        }

        @Override
        public void run() {
            try {
                PrintWriter pw = null;
                if (this.outs!=null) {
                    pw = new PrintWriter(this.outs);
                }

                BufferedReader br = new BufferedReader(new InputStreamReader(this.is));
                String line = null;
                StringBuffer sb = new StringBuffer();
                while ((line = br.readLine()) != null) {
                    if (pw != null) {
                        pw.println(line);
                    }
                    sb.append(typeString+line).append('\n');
                    this.result.append(line).append('\n');
                }
                if (pw != null) {
                    pw.flush();
                }
                if (this.print==true) {
                    System.out.println(sb.toString());
                }
                if (this.outs!=null) {
                    this.outs.flush();
                    this.outs.close();
                }
            } catch (IOException ioe) {
                ioe.printStackTrace();
            }
        }
        
        public String getResult() {
            return this.result.toString();
        }
    }

//    public static void main(String[] args) {
//        String[] ax = new String[]{"-EMLAxiomLogT=1"};
//        String arg = "T.dfg";
//        Run r = new Run(ax, arg);
//        System.out.println(r.getResult());
//    }
}
