package jasper.main;
import jasper.element.axioms.*;
import jasper.exceptions.*;
import jasper.element.*;
import jasper.element.symbols.*;
import jasper.data.*;
import java.io.*;
//Axiomatic Translation, version 1.1.0, @K.J.Smith 2007-2008, http://project.kjsmith.net/
public class TranslationManager implements Constants {

    private static final TranslationManager tm = new TranslationManager();
//    private static final InputOptions inputOptions = new InputOptions();
    private static OutputTerm outputTerm = null;
    private static final SymbolCache symbols = new SymbolCache();
    private static String[] args;
    
    private TranslationManager() {
    }

    public void setArgs(String[] args) {
        TranslationManager.args = args;
    }

    public void manage() {
        this.processArgs();
                
        for (int i = 0; i < EXAMPLES.length; i++) {
//        for (int i = 33; i < 34; i++) {    
            //access the SPASSrelease version
            StringBuffer sb = new StringBuffer();
            String[] axflag=null;
                                
            for (int j = 0; j < 147; j++) { //0-147 
                outputTerm = new OutputTerm();
                Axiom ax = null;
                //set the axioms, in order
                System.out.println("case:"+j+"; Example:"+i);
                sb.append("case "+j+"; Example:"+i).append('\n');
                
                TranslationManager.symbols.namesReset();
                
                switch (j) {
                    case 0:
                        axflag = new String[0];
                        break;
                    case 1:
                        ax = new AxiomT(ModalityIndex.dummy);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName());
                        sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLogT=1"};
                        break;
                    case 2:
                        ax = new Axiom4(ModalityIndex.dummy);
                        outputTerm.addAxiom(ax);
                        ax.setModeComposition(false);
                        System.out.println(ax.getName());
                        sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLog4=1"};
                        break;
                    case 3:
                        ax = new Axiom5(ModalityIndex.dummy);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName());
                        sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLog5=1"};
                        break;
                    case 4:
                        ax = new AxiomAlt1(ModalityIndex.dummy);
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName());
                        sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLogAlt1=1"};
                        break;
                    case 5:
                        ax = new AxiomB(ModalityIndex.dummy);
                        outputTerm.addAxiom(ax);
                        ax.setModeComposition(false);
                        System.out.println(ax.getName());
                        sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLogB=1"};
                        break;
                    case 6:
                        ax = new AxiomD(ModalityIndex.dummy);
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName());
                        sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLogD=1"};
                        break;
                    ///////////////  
                    case 7: //LogT=1 Log4=1 T4.out
                        //7: Requested Composition ..... K,T,4
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLogT=1", "-EMLAxiomLog4=1"};
                        break;
                    case 8: //LogT=1 LogB=1 TB.out
                        //8: ..... K,T,B
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLogT=1", "-EMLAxiomLogB=1"};
                        break;
                    case 9: //LogD=1 LogB=1 DB.out
                        //9: ..... K,D,B
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLogD=1", "-EMLAxiomLogB=1"};
                        break;
                    case 10: //LogD=1 Log4=1 D4.out
                        //10: ..... K,D,4
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLogD=1", "-EMLAxiomLog4=1"};
                        break;
                    case 11: //Log4=1 LogB=1 4B.out
                        //11: ..... K,4o,B
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLog4=1", "-EMLAxiomLogB=1"};
                        break;
                    case 12: //Log5=1 LogB=1 5oB.out
                        //12: ..... K,5o,B
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLog5=1", "-EMLAxiomLogB=1"};
                        break;
                    case 13: //LogT=1 Log5=1 5oT.out
                        //13: ..... K,5o,T
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLogT=1", "-EMLAxiomLog5=1"};
                        break;
                    case 14: //LogT=1 Log4=1 LogB=1 T4B.out
                        //14: ..... K,T,4o,B
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLogT=1", "-EMLAxiomLog4=1", "-EMLAxiomLogB=1"};
                        break;
                    case 15: //LogD=1 Log4=1 LogB=1 D4B.out
                        //15: ..... K,D,4o,B
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLogD=1", "-EMLAxiomLog4=1", "-EMLAxiomLogB=1"};
                        break;                              
                    case 16: //HidOpt=901000000 LogT=1 Log5=2 T5.out
                        //16: ..... K,T,5o
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLog5=2"};
                        break;  
                    case 17: //HidOpt=901001000 LogD=1 Log4=1 Log5=1 D45.out
                        //17: ..... K,D,5,4
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901001000", 
                         "-EMLAxiomLogD=1", "-EMLAxiomLog4=1", "-EMLAxiomLog5=1"};
                        break;
                    case 18: //HidOpt=901000000 LogD=1 Log4=2 Log5=3 Do4o5.out
                        //18: ..... K,Do,4o,5o
                         ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLog4=2", "-EMLAxiomLog5=3"};
                        break;
                    case 19: //HidOpt=901000000 LogD=1 Log4=3 Log5=2 Do5o4.out
                        //19: ..... K,Do,5o,4o
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLog5=2", "-EMLAxiomLog4=3"};
                        break;
                    case 20: //HidOpt=901000000 LogD=2 Log4=1 Log5=3 4oDo5.out
                        //20: ..... K,4o,Do,5o
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogD=2", "-EMLAxiomLog5=3"};
                        break;
                    case 21: //HidOpt=901000000 LogD=3 Log4=1 Log5=2 4o5oD.out
                        //21: ..... K,4o,5o,Do
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLog5=2", "-EMLAxiomLogD=3"};
                        break;
                    case 22: //HidOpt=901000000 LogD=2 Log4=3 Log5=1 5oDo4.out
                        //22: ..... K,Do,5o,4o
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogD=1", "-EMLAxiomLog4=3"};
                        break;
                    case 23: //HidOpt=901000000 LogD=3 Log4=2 Log5=1 5o4oD.out
                        //23: ..... K,5o,4o,Do
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLog4=2", "-EMLAxiomLogD=3"};
                        break;
                    case 24: //HidOpt=901001000 LogB=1 Log5=2 B5.out
                        //24: ..... K,B,5
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901001000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog5=2"};
                        break;
                    case 25: //HidOpt=901000000 LogB=1 Log5=2 Bo5.out
                        //25: ..... K,Bo,5o
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog5=2"};
                        break;
                    case 26: //HidOpt=901000000 LogB=2 Log5=1 5oB.out
                        //26: ..... K,5o,Bo
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogB=2"};
                        break;
                    case 27: //HidOpt=901001000 LogB=1 Log4=2 B4.out
                        //27: ..... K,B,4
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901001000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog4=2"};
                        break;
                    case 28: //HidOpt=901000000 Log4=1 LogB=2 4oB.out
                        //28: ..... K,4o,Bo
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogB=2"};
                        break;
                    case 29: //HidOpt=901000000 Log4=2 LogB=1 Bo4.out
                        //29: ..... K,Bo,4o
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog4=2"};
                        break;
                    case 30: //HidOpt=901000000 LogT=2 LogB=1 BoT.out
                        //30: ..... K,Bo,T
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLogT=2"};
                        break;
                    case 31: //HidOpt=901000000 LogT=1 LogB=2 ToB.out
                        //31: ..... K,T,Bo
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLogB=2"};
                        break;
                    case 32: //HidOpt=901001000 LogB=1 LogT=2 BT.out
                        //32: ..... K,B,T
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901001000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLogT=2"};
                        break;
                    case 33: //HidOpt=901001000 LogD=1 LogT=1 DT.out
                        //33: ..... K,T,D
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901001000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLogT=1"};
                        break;
                    case 34: //HidOpt=901000000 LogD=1 LogT=2 DoT.out
                        //34: ..... K,Do,T
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLogT=2"};
                        break;
                    case 35: //HidOpt=901000000 LogD=2 LogT=1 TD.out
                        //35: ..... K,T,Do
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLogD=2"};
                        break;
                   case 36: //HidOpt=901001000 LogD=1 Log5=1 LogB=1 D5B.out
                       //36: ..... K,D,5,B
                       ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n'); 
                        axflag = new String[]{"-EMLAxiomHidOpt=901001000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLog5=1", "-EMLAxiomLogB=1"};
                        break;
                   case 37: //HidOpt=901000000 LogD=1 Log5=2 LogB=3 Do5oB.out
                        //37: ..... K,Do,5o,Bo
                       ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLog5=2", "-EMLAxiomLogB=3"};
                        break;
                   case 38: //HidOpt=901000000 LogD=1 Log5=3 LogB=2 DoBo5.out
                        //38: ..... K,Do,Bo,5o
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLogB=2", "-EMLAxiomLog5=3"};
                        break;
                   case 39: //HidOpt=901000000 LogD=2 Log5=1 LogB=3 5oDoB.out
                        //39: ..... K,5o,Do,Bo
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogD=2", "-EMLAxiomLogB=3"};
                        break;
                   case 40: //HidOpt=901000000 LogD=3 Log5=1 LogB=2 5oBoD.out
                        //40: ..... K,5o,Bo,Do
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogB=2", "-EMLAxiomLogD=3"};
                        break;
                   case 41: //HidOpt=901000000 LogD=3 Log5=2 LogB=1 Bo5oD.out
                        //41: ..... K,Bo,5o,Do
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog5=2", "-EMLAxiomLogD=3"};
                        break;
                   case 42: //HidOpt=901000000 LogD=2 Log5=3 LogB=1 BoDo5.out
                        //42: ..... K,Bo,Do,5o
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLogD=2", "-EMLAxiomLog5=3"};
                        break;
                   case 43: //HidOpt=901001000 LogD=1 Log4=1 LogB=1 Log5=1 D4B5.out
                        //43: ..... K,D,5,4,B
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901001000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLog4=1", "-EMLAxiomLogB=1", "-EMLAxiomLog5=1"};
                        break;
                   case 44: //HidOpt=901000000 LogD=1 Log4=2 LogB=3 Log5=4 Do4oBo5.out
                        //44: ..... K,Do,4o,Bo,5o
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLog4=2", "-EMLAxiomLogB=3", "-EMLAxiomLog5=4"};
                        break;
                   case 45: //HidOpt=901000000 LogD=1 Log4=2 LogB=4 Log5=3 Do4o5oB.out
                        //45: ..... K,Do,4o,5o,Bo
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLog4=2", "-EMLAxiomLog5=3", "-EMLAxiomLogB=4"};
                        break;
                   case 46: //HidOpt=901000000 LogD=1 Log4=4 LogB=3 Log5=2 Do5oBo4.out
                        //46: ..... K,Do,5o,Bo,4o
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLog5=2", "-EMLAxiomLogB=3", "-EMLAxiomLog4=4"};
                        break;
                   case 47: //HidOpt=901000000 LogD=1 Log4=3 LogB=4 Log5=2 Do5o4oB.out
                        //47: ..... K,Do,5o,4o,Bo
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLog5=2", "-EMLAxiomLog4=3", "-EMLAxiomLogB=4"};
                        break;
                   case 48: //HidOpt=901000000 LogD=1 Log4=3 LogB=2 Log5=4 DoBo4o5.out
                        //48: ..... K,Do,Bo,4o,5o
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLogB=2", "-EMLAxiomLog4=3", "-EMLAxiomLog5=4"};
                        break;
                   case 49: //HidOpt=901000000 LogD=1 Log4=4 LogB=2 Log5=3 DoBo5o4.out
                        //49: ..... K,Do,Bo,5o,4o
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLogB=2", "-EMLAxiomLog5=3", "-EMLAxiomLog4=4"};
                        break;
                   case 50: //HidOpt=901001000 Log4=1 LogB=1 Log5=1 4B5.out
                        //50: ..... K,5,4,B
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901001000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogB=1", "-EMLAxiomLog5=1"};
                        break;
                   case 51: //HidOpt=901000000 Log4=1 LogB=2 Log5=3 4oBo5.out
                        //51: ..... K,4o,Bo,5o
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogB=2", "-EMLAxiomLog5=3"};
                        break;
                   case 52: //HidOpt=901000000 Log4=1 LogB=3 Log5=2 4o5oB.out
                        //52: ..... K,4o,5o,Bo
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLog5=2", "-EMLAxiomLogB=3"};
                        break;
                   case 53: //HidOpt=901000000 Log4=3 LogB=2 Log5=1 5oBo4.out
                        //53: ..... K,5o,Bo,4o
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogB=2", "-EMLAxiomLog4=3"};
                        break;
                   case 54: //HidOpt=901000000 Log4=2 LogB=3 Log5=1 5o4oB.out
                        //54: ..... K,5o,4o,Bo
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLog4=2", "-EMLAxiomLogB=3"};
                        break;
                   case 55: //HidOpt=901000000 Log4=2 LogB=1 Log5=3 Bo4o5.out
                        //55: ..... K,Bo,4o,5o
                        //expected
                        //def...
                        // p        []p         []¬[]p 
                        // [][]p    [][]¬[]p    []¬[]¬[]p
                        // []¬[][]p     []¬[][]¬[]p
                        // B([]p)
                        // 4([]p)      4([]¬[]p)
                        // 5([]p)  5([]¬[]p) 5([][]p)   5([][]¬[]p)
                        // 5([]¬[]¬[]p)  5([]¬[][]p) 5([]¬[][]¬[]p)
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog4=2", "-EMLAxiomLog5=3"};
                        break;
                   case 56: //HidOpt=901000000 Log4=3 LogB=1 Log5=2 Bo5o4.out
                        //56: ..... K,Bo,5o,4o
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog5=2", "-EMLAxiomLog4=3"};
                        break;
                   case 57: //HidOpt=901001000 LogD=1 Log4=1 LogB=1 D4B.out
                        //57: ..... K,D,4,B
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901001000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLog4=1", "-EMLAxiomLogB=1"};
                        break;
                   case 58: //HidOpt=901000000 LogD=1 Log4=2 LogB=3 Do4oB.out
                        //58: ..... K,Do,4o,Bo
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLog4=2", "-EMLAxiomLogB=3"};
                        break;
                   case 59: //HidOpt=901000000 LogD=1 Log4=3 LogB=2 DoBo4.out
                        //59: ..... K,Do,Bo,4o
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogD=1", "-EMLAxiomLogB=2", "-EMLAxiomLog4=3"};
                        break;
                   case 60: //HidOpt=901000000 LogD=2 Log4=3 LogB=1 BoDo4.out
                        //60: ..... K,Bo,Do,4o
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLogD=2", "-EMLAxiomLog4=3"};
                        break;
                   case 61: //HidOpt=901000000 LogD=3 Log4=2 LogB=1 Bo4oD.out
                        //61: ..... K,Bo,4o,Do
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog4=2", "-EMLAxiomLogD=3"};
                        break;
                   case 62: //HidOpt=901000000 LogD=2 Log4=1 LogB=3 4oDoB.out
                        //62: ..... K,4o,Do,Bo
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogD=2", "-EMLAxiomLogB=3"};
                        break;
                   case 63: //HidOpt=901000000 LogD=3 Log4=1 LogB=2 4oBoD.out
                        //63: ..... K,4o,Bo,Do
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogB=2", "-EMLAxiomLogD=3"};
                        break;  
                   case 64: //HidOpt=901001000 LogT=1 Log4=1 Log5=1 T45.out
                        //64: ..... K,T,5,4
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901001000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLog4=1", "-EMLAxiomLog5=1"};
                        break;
                   case 65: //HidOpt=901000000 LogT=1 Log4=2 Log5=3 T4o5.out
                        //65: ..... K,T,4o,5o
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLog4=2", "-EMLAxiomLog5=3"};
                        break;
                   case 66: //HidOpt=901000000 LogT=1 Log5=1 Log4=1 T5o4.out
                        //66: ..... K,T,5o,4o
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLog5=1", "-EMLAxiomLog4=1"};
                        break;
                   case 67: //HidOpt=901000000 LogT=2 Log4=1 Log5=3 4oT5.out
                        //67: ..... K,4o,T,5o
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogT=2", "-EMLAxiomLog5=3"};
                        break;
                   case 68: //HidOpt=901000000 LogT=3 Log4=1 Log5=2 4o5oT.out
                        //68: ..... K,4o,5o,T
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLog5=2", "-EMLAxiomLogT=3"};
                        break;
                   case 69: //HidOpt=901000000 LogT=2 Log4=3 Log5=1 5oT4.out
                        //69: ..... K,5o,T,4o
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogT=2", "-EMLAxiomLog4=3"};
                        break;
                   case 70: //HidOpt=901000000 LogT=3 Log4=2 Log5=1 5o4oT.out 
                        //70: ..... K,5o,4o,T
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLog4=2", "-EMLAxiomLogT=3"};
                        break;
                   case 71: //HidOpt=901001000 LogT=1 Log4=1 LogB=1 Log5=1 T4B5.out
                        //71: ..... K,T,5,4,B
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901001000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLog4=1", "-EMLAxiomLogB=1", "-EMLAxiomLog5=1"};
                        break;
                   case 72: //HidOpt=901000000 LogT=1 Log4=2 LogB=3 Log5=4 T4oBo5.out
                        //72: ..... K,T,4o,Bo,5o
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLog4=2", "-EMLAxiomLogB=3", "-EMLAxiomLog5=4"};
                        break;
                   case 73: //HidOpt=901000000 LogT=1 Log4=2 LogB=4 Log5=3 T4o5oB.out
                        //73: ..... K,T,4o,5o,Bo
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLog4=2", "-EMLAxiomLog5=3", "-EMLAxiomLogB=4"};
                        break;
                   case 74: //HidOpt=901000000 LogT=1 Log4=4 LogB=3 Log5=2 T5oBo4.out
                        //74: ..... K,T,5o,Bo,4o
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLog5=2", "-EMLAxiomLogB=3", "-EMLAxiomLog4=4"};
                        break;
                   case 75: //HidOpt=901000000 LogT=1 Log4=3 LogB=4 Log5=2 T5o4oB.out
                        //75: ..... K,T,5o,4o,Bo
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLog5=2", "-EMLAxiomLog4=3", "-EMLAxiomLogB=4"};
                        break;
                   case 76: //HidOpt=901000000 LogT=1 Log4=3 LogB=2 Log5=4 TBo4o5.out
                        //76: ..... K,T,Bo,4o,5o
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLogB=2", "-EMLAxiomLog4=3", "-EMLAxiomLog5=4"};
                        break;
                   case 77: //HidOpt=901000000 LogT=1 Log4=4 LogB=2 Log5=3 TBo5o4.out
                        //77: ..... K,T,Bo,5o,4o
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLogB=2", "-EMLAxiomLog5=3", "-EMLAxiomLog4=4"};
                        break;
                   case 78: //HidOpt=901001000 LogT=1 LogB=1 Log5=1 TB5.out
                        //78: ..... K,T,5,B
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901001000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLogB=1", "-EMLAxiomLog5=1"};
                        break;
                   case 79: //HidOpt=901000000 LogT=1 LogB=2 Log5=3 ToBo5.out
                        //79: ..... K,T,Bo,5o
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLogB=2", "-EMLAxiomLog5=3"};
                        break;
                   case 80: //HidOpt=901000000 LogT=1 LogB=3 Log5=2 To5oB.out
                        //80: ..... K,T,5o,Bo
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLog5=2", "-EMLAxiomLogB=3"};
                        break;
                   case 81: //HidOpt=901000000 LogT=3 LogB=2 Log5=1 5oBoT.out
                        //81: ..... K,5o,Bo,T
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogB=2", "-EMLAxiomLogT=3"};
                        break;
                   case 82: //HidOpt=901000000 LogT=2 LogB=3 Log5=1 5oTB.out
                        //82: ..... K,5o,T,Bo
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogT=2", "-EMLAxiomLogB=3"};
                        break;
                   case 83: //HidOpt=901000000 LogT=2 LogB=1 Log5=3 BoT5.out
                        //83: ..... K,Bo,T,5o
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLogT=2", "-EMLAxiomLog5=3"};
                        break;
                   case 84: //HidOpt=901000000 LogT=3 LogB=1 Log5=2 Bo5oT.out
                        //84: ..... K,Bo,5o,T
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog5=2", "-EMLAxiomLogT=3"};
                        break;       
                   case 85: //HidOpt=901001000 LogT=1 Log4=1 LogB=1 T4B.out
                        //85: ..... K,T,4,B
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901001000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLog4=1", "-EMLAxiomLogB=1"};
                        break;
                   case 86: //HidOpt=901000000 LogT=1 Log4=2 LogB=3 To4oB.out
                        //86: ..... K,T,4o,Bo
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLog4=2", "-EMLAxiomLogB=3"};
                        break;
                   case 87: //HidOpt=901000000 LogT=1 Log4=3 LogB=2 ToBo4.out
                        //87: ..... K,T,Bo,4o
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLogB=2", "-EMLAxiomLog4=3"};
                        break;
                   case 88: //HidOpt=901000000 LogT=3 Log4=1 LogB=2 4oBoT.out
                        //88: ..... K,4o,Bo,T
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogB=2", "-EMLAxiomLogT=3"};
                        break;
                   case 89: //HidOpt=901000000 LogT=1 Log4=2 LogB=3 T4oB.out
                        //89: ..... K,T,4o,Bo
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLog4=2", "-EMLAxiomLogB=3"};
                        break;
                   case 90: //HidOpt=901000000 LogT=1 Log4=3 LogB=2 TBo4.out
                        //90: ..... K,T,Bo,4o
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogT=1", "-EMLAxiomLogB=2", "-EMLAxiomLog4=3"};
                        break;
                   case 91: //HidOpt=901000000 LogT=3 Log4=1 LogB=2 4oBoT.out
                        //91: ..... K,4o,Bo,T
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogB=2", "-EMLAxiomLogT=3"};
                        break;
                   case 92: //HidOpt=901000000 LogT=2 Log4=1 LogB=3 4oTB.out
                        //92: ..... K,4o,T,Bo
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogT=2", "-EMLAxiomLogB=3"};
                        break;
                   case 93: //HidOpt=901000000 LogT=3 Log4=2 LogB=1 Bo4oT.out
                        //93: ..... K,Bo,4o,T
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog4=2", "-EMLAxiomLogT=3"};
                        break;
                   case 94: //HidOpt=901000000 LogT=2 Log4=3 LogB=1 BoT4.out
                        //94: ..... K,Bo,T,4o
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLogT=2", "-EMLAxiomLog4=3"};
                        break;
                   case 95: //HidOpt=901000000 Log4=1 LogT=2 LogB=3 Log5=4 4oTBo5.out
                        //95: ..... K,4o,T,Bo,5o
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogT=2", "-EMLAxiomLogB=3", "-EMLAxiomLog5=4"};
                        break;
                   case 96: //HidOpt=901000000 Log4=1 LogT=2 LogB=4 Log5=3 4oT5oB.out
                        //96: ..... K,4o,T,5o,Bo
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogT=2", "-EMLAxiomLog5=3", "-EMLAxiomLogB=4"};
                        break;
                   case 97: //HidOpt=901000000 Log4=1 LogT=4 LogB=3 Log5=2 4o5oBoT.out
                        //97: ..... K,4o,5o,Bo,T
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLog5=2", "-EMLAxiomLogB=3", "-EMLAxiomLogT=4"};
                        break;
                   case 98: //HidOpt=901000000 Log4=1 LogT=3 LogB=4 Log5=2 4o5oTB.out
                        //98: ..... K,4o,5o,T,Bo
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLog5=2", "-EMLAxiomLogT=3", "-EMLAxiomLogB=4"};
                        break;
                   case 99: //HidOpt=901000000 Log4=1 LogT=3 LogB=2 Log5=4 4oBoT5.out
                        //99: ..... K,4o,Bo,T,5o
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogB=2", "-EMLAxiomLogT=3", "-EMLAxiomLog5=4"};
                        break;
                   case 100: //HidOpt=901000000 Log4=1 LogT=4 LogB=2 Log5=3 4oBo5oT.out
                        //100: ..... K,4o,Bo,5o,T
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogB=2", "-EMLAxiomLog5=3", "-EMLAxiomLogT=4"};
                        break;
                   case 101: //HidOpt=901000000 LogB=1 Log4=2 LogT=3 Log5=4 Bo4oT5.out
                        //101: ..... K,Bo,4o,T,5o
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog4=2", "-EMLAxiomLogT=3", "-EMLAxiomLog5=4"};
                        break;
                   case 102: //HidOpt=901000000 LogB=1 Log4=2 LogT=4 Log5=3 Bo4o5oT.out
                        //102: ..... K,Bo,4o,5o,T
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog4=2", "-EMLAxiomLog5=3", "-EMLAxiomLogT=4"};
                        break;
                   case 103: //HidOpt=901000000 LogB=1 Log4=4 LogT=3 Log5=2 Bo5oT4.out
                        //103: ..... K,Bo,5o,T,4o
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog5=2", "-EMLAxiomLogT=3", "-EMLAxiomLog4=4"};
                        break;
                   case 104: //HidOpt=901000000 LogB=1 Log4=3 LogT=4 Log5=2 Bo5o4oT.out
                        //104: ..... K,Bo,5o,4o,T
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog5=2", "-EMLAxiomLog4=3", "-EMLAxiomLogT=4"};
                        break;
                   case 105: //HidOpt=901000000 LogB=1 Log4=3 LogT=2 Log5=4 BoT4o5.out
                        //105: ..... K,Bo,T,4o,5o
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLogT=2", "-EMLAxiomLog4=3", "-EMLAxiomLog5=4"};
                        break;
                   case 106: //HidOpt=901000000 LogB=1 Log4=4 LogT=2 Log5=3 BoT5o4.out
                        //106: ..... K,Bo,T,5o,4o
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLogT=2", "-EMLAxiomLog5=3", "-EMLAxiomLog4=4"};
                        break;
                   case 107: //HidOpt=901000000 Log5=1 Log4=2 LogB=3 LogT=4 5o4oBoT.out
                        //107: ..... K,5o,4o,Bo,T
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLog4=2", "-EMLAxiomLogB=3", "-EMLAxiomLogT=4"};
                        break;
                   case 108: //HidOpt=901000000 Log5=1 Log4=2 LogB=4 LogT=3 5o4oTB.out
                        //108: ..... K,5o,4o,T,Bo
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLog4=2", "-EMLAxiomLogT=3", "-EMLAxiomLogB=4"};
                        break;
                   case 109: //HidOpt=901000000 Log5=1 Log4=4 LogB=3 LogT=2 5oTBo4.out
                        //109: ..... K,5o,T,Bo,4o
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogT=2", "-EMLAxiomLogB=3", "-EMLAxiomLog4=4"};
                        break;
                   case 110: //HidOpt=901000000 Log5=1 Log4=3 LogB=4 LogT=2 5oT4oB.out
                        //110: ..... K,5o,T,4o,Bo
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogT=2", "-EMLAxiomLog4=3", "-EMLAxiomLogB=4"};
                        break;
                   case 111: //HidOpt=901000000 Log5=1 Log4=3 LogB=2 LogT=4 5oBo4oT.out
                        //111: ..... K,5o,Bo,4o,T
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogB=2", "-EMLAxiomLog4=3", "-EMLAxiomLogT=4"};
                        break;
                   case 112: //HidOpt=901000000 Log5=1 Log4=4 LogB=2 LogT=3 5oBoT4.out
                        //112: ..... K,5o,Bo,T,4o
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogB=2", "-EMLAxiomLogT=3", "-EMLAxiomLog4=4"};
                        break;
                   case 113: //HidOpt=901000000 Log4=1 LogD=2 LogB=3 Log5=4 4oDoBo5.out
                        //113: ..... K,4o,Do,Bo,5o
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogD=2", "-EMLAxiomLogB=3", "-EMLAxiomLog5=4"};
                        break;
                   case 114: //HidOpt=901000000 Log4=1 LogD=2 LogB=4 Log5=3 4oDo5oB.out
                        //114: ..... K,4o,Do,5o,Bo
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogD=2", "-EMLAxiomLog5=3", "-EMLAxiomLogB=4"};
                        break;
                   case 115: //HidOpt=901000000 Log4=1 LogD=4 LogB=3 Log5=2 4o5oBoD.out
                        //115: ..... K,4o,5o,Bo,Do
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLog5=2", "-EMLAxiomLogB=3", "-EMLAxiomLogD=4"};
                        break;
                   case 116: //HidOpt=901000000 Log4=1 LogD=3 LogB=4 Log5=2 4o5oDoB.out
                        //116: ..... K,4o,5o,Do,Bo
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLog5=2", "-EMLAxiomLogD=3", "-EMLAxiomLogB=4"};
                        break;
                   case 117: //HidOpt=901000000 Log4=1 LogD=3 LogB=2 Log5=4 4oBoDo5.out
                        //117: ..... K,4o,Bo,Do,5o
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogB=2", "-EMLAxiomLogD=3", "-EMLAxiomLog5=4"};
                        break;
                   case 118: //HidOpt=901000000 Log4=1 LogD=4 LogB=2 Log5=3 4oBo5oD.out
                        //118: ..... K,4o,Bo,5o,Do
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog4=1", "-EMLAxiomLogB=2", "-EMLAxiomLog5=3", "-EMLAxiomLogD=4"};
                        break;
                   case 119: //HidOpt=901000000 LogB=1 Log4=2 LogD=3 Log5=4 Bo4oDo5.out
                        //119: ..... K,Bo,4o,Do,5o
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog4=2", "-EMLAxiomLogD=3", "-EMLAxiomLog5=4"};
                        break;
                   case 120: //HidOpt=901000000 LogB=1 Log4=2 LogD=4 Log5=3 Bo4o5oD.out
                        //120: ..... K,Bo,4o,5o,Do
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog4=2", "-EMLAxiomLog5=3", "-EMLAxiomLogD=4"};
                        break;
                   case 121: //HidOpt=901000000 LogB=1 Log4=4 LogD=3 Log5=2 Bo5oDo4.out
                        //121: ..... K,Bo,5o,Do,4o
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog5=2", "-EMLAxiomLogD=3", "-EMLAxiomLog4=4"};
                        break;
                   case 122: //HidOpt=901000000 LogB=1 Log4=3 LogD=4 Log5=2 Bo5o4oD.out
                        //122: ..... K,Bo,5o,4o,Do
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLog5=2", "-EMLAxiomLog4=3", "-EMLAxiomLogD=4"};
                        break;
                   case 123: //HidOpt=901000000 LogB=1 Log4=3 LogD=2 Log5=4 BoDo4o5.out
                        //123: ..... K,Bo,Do,4o,5o
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLogD=2", "-EMLAxiomLog4=3", "-EMLAxiomLog5=4"};
                        break;
                   case 124: //HidOpt=901000000 LogB=1 Log4=4 LogD=2 Log5=3 BoDo5o4.out
                        //124: ..... K,Bo,Do,5o,4o
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLogB=1", "-EMLAxiomLogD=2", "-EMLAxiomLog5=3", "-EMLAxiomLog4=4"};
                        break;
                   case 125: //HidOpt=901000000 Log5=1 Log4=2 LogB=3 LogD=4 5o4oBoD.out
                        //125: ..... K,5o,4o,Bo,Do
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLog4=2", "-EMLAxiomLogB=3", "-EMLAxiomLogD=4"};
                        break;
                   case 126: //HidOpt=901000000 Log5=1 Log4=2 LogB=4 LogD=3 5o4oDoB.out
                        //126: ..... K,5o,4o,Do,Bo
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLog4=2", "-EMLAxiomLogD=3", "-EMLAxiomLogB=4"};
                        break;
                   case 127: //HidOpt=901000000 Log5=1 Log4=4 LogB=3 LogD=2 5oDoBo4.out
                        //127: ..... K,5o,Do,Bo,4o
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogD=2", "-EMLAxiomLogB=3", "-EMLAxiomLog4=4"};
                        break;
                   case 128: //HidOpt=901000000 Log5=1 Log4=3 LogB=4 LogD=2 5oDo4oB.out
                        //128: ..... K,5o,Do,4o,Bo
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogD=2", "-EMLAxiomLog4=3", "-EMLAxiomLogB=4"};
                        break;
                   case 129: //HidOpt=901000000 Log5=1 Log4=3 LogB=2 LogD=4 5oBo4oD.out
                        //129: ..... K,5o,Bo,4o,Do
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogB=2", "-EMLAxiomLog4=3", "-EMLAxiomLogD=4"};
                        break;
                   case 130: //HidOpt=901000000 Log5=1 Log4=4 LogB=2 LogD=3 5oBoDo4.out
                        //130: ..... K,5o,Bo,Do,4o
                        ax = new Axiom5(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomB(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomD(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new Axiom4(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000",
                         "-EMLAxiomLog5=1", "-EMLAxiomLogB=2", "-EMLAxiomLogD=3", "-EMLAxiomLog4=4"};
                        break;
                   //////////////////////////////////
                   case 131: //Log4K=1 LogFac4=2 4^2.out
                        ax = new Axiom42(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomLog4K=1", "-EMLAxiomLogFac4=2"};
                        break;
                   case 132: //Log4K=1 LogFac4=3 4^3.out
                        ax = new Axiom43(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');                        
                        axflag = new String[]{"-EMLAxiomLog4K=1", "-EMLAxiomLogFac4=3"};
                        break;
                   case 133: //Log5K=1 LogFac5=2 5^2.out
                        ax = new Axiom52(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');                        
                        axflag = new String[]{"-EMLAxiomLog5K=1", "-EMLAxiomLogFac5=2"};
                        break;
                   case 134: //Log5K=1 LogFac5=3 5^3.out
                        ax = new Axiom53(ModalityIndex.dummy);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');                       
                        axflag = new String[]{"-EMLAxiomLog5K=1", "-EMLAxiomLogFac5=3"};
                        break;
                   case 135: //LogAlt1KK=1 LogFac1=1 LogFac2=1 alt1^1,1.out
                        ax = new AxiomAlt1_11(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');                 
                        axflag = new String[]{"-EMLAxiomLogAlt1KK=1", "-EMLAxiomLogFac1=1", "-EMLAxiomLogFac2=1"};
                        break;
                   case 136: //LogAlt1KK=1 LogFac1=2 LogFac2=1 alt1^2,1.out
                        ax = new AxiomAlt1_21(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');                        
                        axflag = new String[]{"-EMLAxiomLogAlt1KK=1", "-EMLAxiomLogFac1=2", "-EMLAxiomLogFac2=1"};
                        break;
                   case 137: //LogAlt1KK=1 LogFac1=1 LogFac2=2 alt1^1,2.out
                        ax = new AxiomAlt1_12(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');                        
                        axflag = new String[]{"-EMLAxiomLogAlt1KK=1", "-EMLAxiomLogFac1=1", "-EMLAxiomLogFac2=2"};
                        break;
                   case 138: //LogAlt1KK=1 LogFac1=2 LogFac2=2 alt1^2,2.out
                        ax = new AxiomAlt1_22(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');                        
                        axflag = new String[]{"-EMLAxiomLogAlt1KK=1", "-EMLAxiomLogFac1=2", "-EMLAxiomLogFac2=2"};
                        break;
                    //----------------------
                    case 139: //Log4K=1 LogFac4=2 4^2.out
                        ax = new Axiom42(ModalityIndex.dummy);
                         ax.setModeComposition(true);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000", "-EMLAxiomLogT=2",
                            "-EMLAxiomLog4K=1", "-EMLAxiomLogFac4=2"};
                        break;
                   case 140: //Log4K=1 LogFac4=3 4^3.out
                        ax = new Axiom43(ModalityIndex.dummy);
                         ax.setModeComposition(true);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');                        
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000", "-EMLAxiomLogT=2",
                            "-EMLAxiomLog4K=1", "-EMLAxiomLogFac4=3"};
                        break;
                   case 141: //Log5K=1 LogFac5=2 5^2.out
                        ax = new Axiom52(ModalityIndex.dummy);
                         ax.setModeComposition(true);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');                        
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000", "-EMLAxiomLogT=2",
                            "-EMLAxiomLog5K=1", "-EMLAxiomLogFac5=2"};
                        break;
                   case 142: //Log5K=1 LogFac5=3 5^3.out
                        ax = new Axiom53(ModalityIndex.dummy);
                         ax.setModeComposition(true);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000", "-EMLAxiomLogT=2",
                            "-EMLAxiomLog5K=1", "-EMLAxiomLogFac5=3"};
                        break;
                   case 143: //LogAlt1KK=1 LogFac1=1 LogFac2=1 alt1^1,1.out
                        ax = new AxiomAlt1_11(ModalityIndex.dummy);
                         ax.setModeComposition(true);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000", "-EMLAxiomLogT=2",
                            "-EMLAxiomLogAlt1KK=1", "-EMLAxiomLogFac1=1", "-EMLAxiomLogFac2=1"};
                        break;
                   case 144: //LogAlt1KK=1 LogFac1=2 LogFac2=1 alt1^2,1.out
                        ax = new AxiomAlt1_21(ModalityIndex.dummy);
                         ax.setModeComposition(true);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000", "-EMLAxiomLogT=2",
                            "-EMLAxiomLogAlt1KK=1", "-EMLAxiomLogFac1=2", "-EMLAxiomLogFac2=1"};
                        break;
                   case 145: //LogAlt1KK=1 LogFac1=1 LogFac2=2 alt1^1,2.out
                        ax = new AxiomAlt1_12(ModalityIndex.dummy);
                         ax.setModeComposition(true);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000", "-EMLAxiomLogT=2",
                            "-EMLAxiomLogAlt1KK=1", "-EMLAxiomLogFac1=1", "-EMLAxiomLogFac2=2"};
                        break;
                   case 146: //LogAlt1KK=1 LogFac1=2 LogFac2=2 alt1^2,2.out
                        ax = new AxiomAlt1_22(ModalityIndex.dummy);
                         ax.setModeComposition(true);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        ax = new AxiomT(ModalityIndex.dummy);
                         ax.setModeComposition(false);
                         outputTerm.addAxiom(ax);
                         System.out.println(ax.getName());
                         sb.append(ax.getName()).append('\n');
                        axflag = new String[]{"-EMLAxiomHidOpt=901000000", "-EMLAxiomLogT=2",
                            "-EMLAxiomLogAlt1KK=1", "-EMLAxiomLogFac1=2", "-EMLAxiomLogFac2=2"};
                        break;
                  //------------------------------
                    
                }

                //set the term
                outputTerm.setTerm(EXAMPLES[i]); // T
                System.out.println("Test Term = " //+ EXAMPLES[i].getDescription()
                    +" "+EXAMPLES[i].toString());
                sb.append("Test Term = " //+ EXAMPLES[i].getNemonic()
                    +" "+EXAMPLES[i].toString()).append('\n');
                
                //perform the translation
                outputTerm.translate();
            
                //get the output
                Term out = outputTerm.getOutTerm();
                out = out.simplfyAnds();
                System.out.print("java term =  "); out.print();
                sb.append("Java term =  ").append(out.toString()).append('\n');
                
                Run run = new Run(axflag, DFGS[i]);
                String result = run.getResult();
                ParseDFG dfg = new ParseDFG(result);
                Term term = dfg.getResult();
                term = term.simplfyAnds();
                System.out.print("SPASS term "+DFGS[i]+"= "); term.print();
                sb.append("SPASS term "+DFGS[i]+"= ").append(term.toString()).append('\n');
         
                if (out.equals(term)==true) {
                    System.out.println("terms are equal");
                    sb.append("terms are equal").append('\n');
                } else {
                    System.out.println("terms are **NOT** equal");
                    sb.append("terms are **NOT** equal").append('\n');
                }
                
                System.out.println("--------------------------------------------");
                sb.append("--------------------------------------------").append('\n');
            }
            Function.save(new File("logs"+File.separator+"log"+i+".txt"), sb.toString());
        }
        
        ////////////////////////////////////////////////////////////
          for (int i = 0; i < 25; i++) {
//        for (int i = 0; i < 1; i++) {   
            StringBuffer sb = new StringBuffer();
                                            
            for (int j = 1; j < 10; j++) { 
                outputTerm = new OutputTerm();
                Axiom ax = null;
                System.out.println("caseTWO:"+j+"; Example:"+i); sb.append("caseTWO"+j+"; Example:"+i).append('\n');
                TranslationManager.symbols.namesReset();
                String axStr = null;
                
                switch (j) {
                    case 1:
                        ax = new AxiomTr(ModalityIndex.dummy);
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = "Tro.";
                        break;
                    case 2:
                        ax = new AxiomB3(ModalityIndex.dummy);
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = "B3o.";
                        break;
                    case 3:
                        ax = new AxiomSR(ModalityIndex.dummy);
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = "SRo.";
                        break;
                     case 4:
                        ax = new AxiomB2(ModalityIndex.dummy);
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = "B2o.";
                        break;   
                     case 5:
                        ax = new AxiomG(ModalityIndex.dummy);
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = "Go.";
                        break;
                     case 6:
                        ax = new AxiomDen(ModalityIndex.dummy);
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = "Deno.";
                        break;
                     case 7:
                        ax = new AxiomDBBB(ModalityIndex.dummy);
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = "DBBBo.";
                        break;
                     case 8:
                        ax = new AxiomM(ModalityIndex.dummy);
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = "Mo.";
                        break;
                     case 9:
                        ax = new AxiomW(ModalityIndex.dummy);
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = "Wo.";
                        break;
                }

                outputTerm.setTerm(EXAMPLES[i]); 
                System.out.println("Test Term = "+" "+EXAMPLES[i].toString()); sb.append("Test Term = "+" "+EXAMPLES[i].toString()).append('\n');
                outputTerm.translate();
            
                Term out = outputTerm.getOutTerm();
                out = out.simplfyAnds();
                System.out.print("java term =  "); out.print(); sb.append("Java term =  ").append(out.toString()).append('\n');
                
                Run run = new Run(axStr+DFGS2[i]+".dfg", "fulloutneu/in"); 
                String result = run.getResult();
                ParseDFG dfg = new ParseDFG(result);
                Term term = dfg.getResult();
                term = term.simplfyAnds();
                System.out.print("SPASS term "+DFGS2[i]+"= "); term.print();
                sb.append("SPASS term "+DFGS2[i]+"= ").append(term.toString()).append('\n');
         
                if (out.equals(term)==true) {
                    System.out.println("terms are equal"); sb.append("terms are equal").append('\n');
                } else {
                    System.out.println("terms are **NOT** equal"); sb.append("terms are **NOT** equal").append('\n');
                }
                
                System.out.println("-------------------------------"); sb.append("---------------------------").append('\n');   
            }
            Function.save(new File("logs2"+File.separator+"log"+i+".txt"), sb.toString());
        } 
        
        ////////////////////////////////////////////////////////////
        for (int i = 0; i < 1; i++) { 
            StringBuffer sb = new StringBuffer();
                                            
            for (int j = 1; j < 58; j++) { 
                outputTerm = new OutputTerm();
                Axiom ax = null;
                System.out.println("caseThree:"+j+"; Example:"+i); sb.append("caseThree"+j+"; Example:"+i).append('\n');
                TranslationManager.symbols.namesReset();
                String axStr = null;
                
                switch (j) {
                    case 1:
                        //Defined AxiomFlag: r  5o 
                        //Defined AxiomFlag: a  5o  
                       ax = new Axiom5(new ModalityIndex("r"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom5(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".5";
                        break;
                    case 2:
                       //Defined AxiomFlag: r  5o 
                       //Defined AxiomFlag: r  B 
                       //Defined AxiomFlag: a  5o 
                       //Defined AxiomFlag: a  B 
                       ax = new Axiom5(new ModalityIndex("r"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomB(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom5(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomB(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".5oB";
                        break;
                    case 3:
                        //Defined AxiomFlag: r  D 
                        //Defined AxiomFlag: r  4 
                        //Defined AxiomFlag: r  B 
                        //Defined AxiomFlag: a  D 
                        //Defined AxiomFlag: a  4 
                        //Defined AxiomFlag: a  B
                       ax = new AxiomD(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom4(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomB(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomD(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom4(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomB(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".D4B";
                        break;
                     case 4:
                        //Defined AxiomFlag: r  D 
                        //Defined AxiomFlag: r  4o 
                        //Defined AxiomFlag: r  B 
                        //Defined AxiomFlag: a  D 
                        //Defined AxiomFlag: a  4o 
                        //Defined AxiomFlag: a  B 
                       ax = new AxiomD(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom4(new ModalityIndex("r"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomB(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomD(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom4(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomB(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       axStr = ".D4oB";
                        break;   
                     case 5:
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: r  4o 
                        //Defined AxiomFlag: r  B 
                        //Defined AxiomFlag: a  T 
                        //Defined AxiomFlag: a  4o 
                        //Defined AxiomFlag: a  B 
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom4(new ModalityIndex("r"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomB(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom4(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomB(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".T4oB";
                        break; 
                        
                     /////////////////////
                    case 6:
                       //Defined AxiomFlag: a  5o  
                       ax = new Axiom5(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".5a";
                        break;
                    case 7:
                       //Defined AxiomFlag: a  5o 
                       //Defined AxiomFlag: a  B 
                       ax = new Axiom5(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomB(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".5oBa";
                        break;
                    case 8:
                        //Defined AxiomFlag: a  D 
                        //Defined AxiomFlag: a  4 
                        //Defined AxiomFlag: a  B
                       ax = new AxiomD(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom4(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomB(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".D4Ba";
                        break;
                     case 9:
                        //Defined AxiomFlag: a  D 
                        //Defined AxiomFlag: a  4o 
                        //Defined AxiomFlag: a  B 
                       ax = new AxiomD(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom4(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomB(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       axStr = ".D4oBa";
                        break;   
                     case 10:
                        //Defined AxiomFlag: a  T 
                        //Defined AxiomFlag: a  4o 
                        //Defined AxiomFlag: a  B 
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom4(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomB(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".T4oBa";
                        break; 
                    case 11:
                        //Defined AxiomFlag: r  5^3o 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  5^3o 
                        //Defined AxiomFlag: a  T
                       ax = new Axiom53(new ModalityIndex("r"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom53(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".5^3oT";
                        break; 
                     case 12:
                        //Defined AxiomFlag: a  5^3o 
                        //Defined AxiomFlag: a  T 
                       ax = new Axiom53(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".5^3oTa";
                        break;
                     case 13:
                        //Defined AxiomFlag: a  T 
                        //Defined AxiomFlag: r  T 
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".To";
                        break; 
                     case 14:
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".Toa";
                        break; 
                     case 15:
                        //Defined AxiomFlag: r  5 
                       ax = new Axiom5(new ModalityIndex("r"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".5r";
                        break; 
                     case 16:
                        //Defined AxiomFlag: r  5^2o 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  5^2o 
                        //Defined AxiomFlag: a  T
                       ax = new Axiom52(new ModalityIndex("r"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom52(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".5^2oT";
                        break; 
                     case 17:
                        //Defined AxiomFlag: a  5^2o 
                        //Defined AxiomFlag: a  T 
                       ax = new Axiom52(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".5^2oTa";
                        break;
                     /////////
                     case 18:
                        //Defined AxiomFlag: r  4o 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  4o 
                        //Defined AxiomFlag: a  T
                       ax = new Axiom4(new ModalityIndex("r"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom4(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".4o.T";
                        break; 
                     case 19:
                        //Defined AxiomFlag: a  4o 
                        //Defined AxiomFlag: a  T 
                       ax = new Axiom4(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".4o.Ta";
                        break;
                     case 20:
                        //Defined AxiomFlag: r  4^2o 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  4^2o 
                        //Defined AxiomFlag: a  T
                       ax = new Axiom42(new ModalityIndex("r"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom42(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".4^2o.T";
                        break; 
                     case 21:
                        //Defined AxiomFlag: a  4^2o 
                        //Defined AxiomFlag: a  T 
                       ax = new Axiom42(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".4^2o.Ta";
                        break;
                    case 22:
                        //Defined AxiomFlag: r  4^3o 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  4^3o 
                        //Defined AxiomFlag: a  T
                       ax = new Axiom43(new ModalityIndex("r"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom43(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".4^3o.T";
                        break; 
                     case 23:
                        //Defined AxiomFlag: a  4^3o 
                        //Defined AxiomFlag: a  T 
                       ax = new Axiom43(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".4^3o.Ta";
                        break;
                     case 24:
                        //Defined AxiomFlag: r  5o 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  5o 
                        //Defined AxiomFlag: a  T
                       ax = new Axiom5(new ModalityIndex("r"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new Axiom5(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".5o.T";
                        break; 
                     case 25:
                        //Defined AxiomFlag: a  5o 
                        //Defined AxiomFlag: a  T 
                       ax = new Axiom5(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".5o.Ta";
                        break;
                    case 26:
                        //Defined AxiomFlag: r  Bo 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  Bo 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomB(new ModalityIndex("r"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomB(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".Bo.T";
                        break; 
                     case 27:
                        //Defined AxiomFlag: a  Bo 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomB(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".Bo.Ta";
                        break;
                     case 28:
                        //Defined AxiomFlag: r  Do 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  Do 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomD(new ModalityIndex("r"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomD(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".Do.T";
                        break; 
                     case 29:
                        //Defined AxiomFlag: a  Do 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomD(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".Do.Ta";
                        break;
                     case 30:
                        //Defined AxiomFlag: r  To 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  To 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".To.T";
                        break; 
                     case 31:
                        //Defined AxiomFlag: a  To 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".To.Ta";
                        break;
                    case 32:
                        //Defined AxiomFlag: r  ALT1o 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  ALT1o 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomAlt1(new ModalityIndex("r"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomAlt1(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".ALT1o.T";
                        break; 
                     case 33:
                        //Defined AxiomFlag: a  ALT1o 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomAlt1(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".ALT1o.Ta";
                        break;
                    case 34:
                        //Defined AxiomFlag: r  ALT1^1,1o 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  ALT1^1,1o 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomAlt1_11(new ModalityIndex("r"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomAlt1_11(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".ALT1^1,1o.T";
                        break; 
                     case 35:
                        //Defined AxiomFlag: a  ALT1^1,1o 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomAlt1_11(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".Alt1^1,1o.Ta";
                        break;
                   case 36:
                        //Defined AxiomFlag: r  ALT1^2,1o 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  ALT1^2,1o 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomAlt1_21(new ModalityIndex("r"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomAlt1_21(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".ALT1^2,1o.T";
                        break; 
                     case 37:
                        //Defined AxiomFlag: a  ALT1^2,1o 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomAlt1_21(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".ALT1^2,1o.Ta";
                        break;
                    case 38:
                        //Defined AxiomFlag: r  ALT1^1,2o 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  ALT1^1,2o 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomAlt1_12(new ModalityIndex("r"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomAlt1_12(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".ALT1^1,2o.T";
                        break; 
                     case 39:
                        //Defined AxiomFlag: a  ALT1^1,2o 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomAlt1_12(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".ALT1^1,2o.Ta";
                        break;
                    case 40:
                        //Defined AxiomFlag: r  ALT1^2,2o 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  ALT1^2,2o 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomAlt1_22(new ModalityIndex("r"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomAlt1_22(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".ALT1^2,2o.T";
                        break; 
                     case 41:
                        //Defined AxiomFlag: a  ALT1^2,2o 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomAlt1_22(new ModalityIndex("a"));
                        ax.setModeComposition(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".ALT1^2,2o.Ta";
                        break;    
                    case 42:
                        //Defined AxiomFlag: r  B^2o 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  B^2o 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomB2(new ModalityIndex("r"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomB2(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".B^2o.T";
                        break; 
                     case 43:
                        //Defined AxiomFlag: a  B^2o 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomB2(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".B^2o.Ta";
                        break;    
                    case 44:
                        //Defined AxiomFlag: r  B^3o 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  B^3o 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomB3(new ModalityIndex("r"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomB3(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".B^3o.T";
                        break; 
                     case 45:
                        //Defined AxiomFlag: a  B^3o 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomB3(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".B^3o.Ta";
                        break; 
                     case 46:
                        //Defined AxiomFlag: r  DBBBo 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  DBBBo 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomDBBB(new ModalityIndex("r"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomDBBB(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".DBBBo.T";
                        break; 
                     case 47:
                        //Defined AxiomFlag: a  DBBBo 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomDBBB(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".DBBBo.Ta";
                        break;
                     case 48:
                        //Defined AxiomFlag: r  Deno 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  Deno 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomDen(new ModalityIndex("r"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomDen(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".Deno.T";
                        break; 
                     case 49:
                        //Defined AxiomFlag: a  Deno 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomDen(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".Deno.Ta";
                        break;
                     case 50:
                        //Defined AxiomFlag: r  Go 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  Go 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomG(new ModalityIndex("r"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomG(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".Go.T";
                        break; 
                     case 51:
                        //Defined AxiomFlag: a  Go 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomG(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".Go.Ta";
                        break; 
                     case 52:
                        //Defined AxiomFlag: r  Mo 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  Mo 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomM(new ModalityIndex("r"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomM(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".Mo.T";
                        break; 
                     case 53:
                        //Defined AxiomFlag: a  Mo 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomM(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".Mo.Ta";
                        break; 
                     case 54:
                        //Defined AxiomFlag: r  SRo 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  SRo 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomSR(new ModalityIndex("r"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomSR(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".SRo.T";
                        break; 
                     case 55:
                        //Defined AxiomFlag: a  SRo 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomSR(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".SRo.Ta";
                        break; 
                    case 56:
                        //Defined AxiomFlag: r  Tro 
                        //Defined AxiomFlag: r  T 
                        //Defined AxiomFlag: a  Tro 
                        //Defined AxiomFlag: a  T
                       ax = new AxiomTr(new ModalityIndex("r"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("r"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomTr(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".Tro.T";
                        break; 
                     case 57:
                        //Defined AxiomFlag: a  Tro 
                        //Defined AxiomFlag: a  T 
                       ax = new AxiomTr(new ModalityIndex("a"));
                        ax.setModeCf5(true);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                       ax = new AxiomT(new ModalityIndex("a"));
                        ax.setModeComposition(false);
                        outputTerm.addAxiom(ax);
                        System.out.println(ax.getName()); 
                        sb.append(ax.getName()).append('\n');
                        axStr = ".Tro.Ta";
                        break; 
                }

                outputTerm.setTerm(MMEXAMPLES[i]); 
                System.out.println("Test Term = "+" "+MMEXAMPLES[i].toString());
                sb.append("Test Term = "+" "+MMEXAMPLES[i].toString()).append('\n');
                outputTerm.translate();
            
                Term out = outputTerm.getOutTerm();
                out = out.simplfyAnds();
                System.out.print("java term =  "); out.print(); sb.append("Java term =  ").append(out.toString()).append('\n');
                
                Run run = new Run(DFGS3[i]+axStr+".MMdfg", "template_mm"); 
                String result = run.getResult();
                ParseDFG dfg = new ParseDFG(result);
                Term term = dfg.getResult();
                term = term.simplfyAnds();
                System.out.print("SPASS term "+DFGS3[i]+"= "); term.print();
                sb.append("SPASS term "+DFGS3[i]+"= ").append(term.toString()).append('\n');
         
                if (out.equals(term)==true) {
                    System.out.println("terms are equal"); sb.append("terms are equal").append('\n');
                } else {
                    System.out.println("terms are **NOT** equal"); sb.append("terms are **NOT** equal").append('\n');
                }
                
                System.out.println("-------------------------------"); sb.append("---------------------------").append('\n');   
            }
            Function.save(new File("logs3"+File.separator+"log"+i+".txt"), sb.toString());
        } 
    }

    private void processArgs() {
        //nothing yet
    }

    public static TranslationManager getTransationManager() {
        return TranslationManager.tm;
    }

    public SymbolCache getSymbolCache() {
        return TranslationManager.symbols;
    }

    public OutputTerm getOutputTerm() {
        if (outputTerm.isInitialized() == false) {
            throw new JasperRuntimeException();
        }
        return TranslationManager.outputTerm;
    }
}
